JSB.require('utils');
// JSB.require('base64')
/** @return {dynamicController} */
const getDynamicController = ()=>self


var dynamicController = JSB.defineClass('dynamicController : UIViewController <NSURLConnectionDelegate>', {
  viewDidLoad: function() {
    try {
    let self = getDynamicController()
    self.init()
    self.appInstance = Application.sharedInstance();
    self.custom = false;
    self.customMode = "None"
    self.funcResponse = ""
    self.dynamic = true;
    self.pinned = false;
    self.markdown = true
    self.miniMode = false;
    self.shouldCopy = false
    self.shouldComment = false
    self.selectedText = '';
    self.searchedText = '';
    self.isLoading = false;
    self.toolbarOn = true;
    self.OCREnhancedMode = false
    // self.currentFrame = self.view.frame
    self.history = []
    self.title = "main"
    self.moveDate = Date.now()
    self.color = [true,true,true,true,true,true,true,true,true,true,true,true,true,true,true,true]

    self.highlightColor = UIColor.blendedColor( hexColorAlpha("#2c4d81",0.8),
      self.appInstance.defaultTextColor,
      0.8
    );
      
    } catch (error) {
      showHUD("Error in viewDidLoad: "+error)
    }
  },
  viewWillAppear: function(animated) {
  },
  viewWillDisappear: function(animated) {
  },
  viewWillLayoutSubviews: function() {
    let studyFrame = studyController().view.frame
    if (self.lastFrame.x+self.lastFrame.width > studyFrame.width) {
      self.lastFrame.x = studyFrame.width-300
    }
    if (self.lastFrame.y+self.lastFrame.height > studyFrame.height) {
      self.lastFrame.y = studyFrame.height-200
    }
    self.view.frame = self.lastFrame
    self.aiButton.frame = genFrame(0, 0, 40, 40)
    self.closeButton.frame = genFrame(5, 5, 35, 35)
    self.sendButton.frame = genFrame(260, 5, 35, 35)
    self.OCREnhanced.frame = genFrame(255, 155, 35, 35)
    self.promptInput.frame = genFrame(45, 5, 210, 35)
    self.scrollview.frame = genFrame(5, 45, 290, 150)
  },
  onMoveGesture:function (gesture) {
    self.pinned = true;
    let locationToMN = gesture.locationInView(studyController().view)
    if (!self.locationToButton || !self.miniMode && (Date.now() - self.moveDate) > 100) {
      let translation = gesture.translationInView(studyController().view)
      let locationToBrowser = gesture.locationInView(self.view)
      let locationToButton = gesture.locationInView(gesture.view)
      let buttonFrame = gesture.view.frame
      let newY = locationToButton.y-translation.y 
      let newX = locationToButton.x-translation.x
      if (gesture.state !== 3 && (newY<buttonFrame.height+5 && newY>-5 && newX<buttonFrame.width+5 && newX>-5 && Math.abs(translation.y)<20 && Math.abs(translation.x)<20)) {
        self.locationToBrowser = {x:locationToBrowser.x-translation.x,y:locationToBrowser.y-translation.y}
        self.locationToButton = {x:newX,y:newY}
      }
      // if ((newY<buttonFrame.height && newY>0 && newX<buttonFrame.width && newX>0 && Math.abs(translation.y)<20 && Math.abs(translation.x)<20) || !self.locationToBrowser) {

      // }
    }
    self.moveDate = Date.now()
    // let location = {x:locationToMN.x - self.locationToBrowser.x,y:locationToMN.y -self.locationToBrowser.y}
    let location = {x:locationToMN.x - self.locationToButton.x-gesture.view.frame.x,y:locationToMN.y -self.locationToButton.y-gesture.view.frame.y}

    let frame = self.view.frame
    let studyFrame = self.appInstance.studyController(self.view.window).view.bounds
    let y = location.y
    if (y<=0) { y = 0 }
    if (y>=studyFrame.height-200) { y = studyFrame.height-200 }
    let x = location.x
    if (x<=0) { x = 0 }
    if (x>=studyFrame.width-300) { x = studyFrame.width-300 }
    self.view.frame = genFrame(x,y,frame.width,frame.height)
    self.lastFrame  = self.view.frame
  },
  closeButtonTapped:async function (params) {
  try {
    

    let self = getNotificationController()
    if (self.connection) {
      self.connection.cancel()
      delete self.connection
    }
    await self.hide()
    self.onChat = false
    if (self.chatView) {
      self.chatView.hidden = true
    }
    self.notificationView.hidden = false
    if (self.markdown) {
      self.webviewResponse.frame = genFrame(0, 0, 400, 85)
      self.sizeHeight = parseInt(await self.runJavaScript(`document.body.scrollHeight`))
    }else{
      self.textviewResponse.frame = genFrame(0, 0, 400, 120)
    }
      } catch (error) {
    showHUD(error)
  }
  },
  openInput:async function () {
    let self = getDynamicController()
    self.onClick = true
    let studyFrame = studyController().view.frame
    if (self.lastFrame.x + 300 > studyFrame.width) {
      self.lastFrame.x = studyFrame.width-300
    }
    if (self.lastFrame.y + 200 > studyFrame.height) {
      self.lastFrame.y = studyFrame.width-200
    }
    self.lastFrame.width = 300
    self.lastFrame.height = 200
    self.aiButton.hidden = true
    self.setLayout(self.lastFrame)
  },
  closeInput:async function () {
    let self = getDynamicController()
    self.onClick = true
    self.pinned = false;
    self.lastFrame.width = 40
    self.lastFrame.height = 40
    self.setLayout(self.lastFrame)
    self.view.hidden = true
    self.aiButton.hidden = false
    self.OCREnhancedMode = false
  },
  toggleOCREnhanceMode:async function (params) {
    self.OCREnhancedMode = !self.OCREnhancedMode
    // if (self.noteId) {
    //   self.OCREnhancedMode = false
    //   showHUD("Not supported for note/card")
    // }
    if (self.OCREnhancedMode) {
      self.OCREnhanced.backgroundColor = hexColorAlpha("#e06c75",0.8)
    }else{
      self.OCREnhanced.backgroundColor = hexColorAlpha("#c0bfbf",0.8)
    }
  },
  askWithPrompt: async function () {
    let self = getDynamicController();
    if (self.noteId) {
      self.askWithPromptOnNote(self.noteId)
      return
    }else{
      self.askWithPromptOnText(self.textSelected)
      return
    }
  },
  onResizeGesture:function (gesture) {
    if (self.notifyTimer) {self.notifyTimer.invalidate()}
    if (self.notifyLoc === 0) {
      self.custom = false;
      self.dynamic = false;
      self.customMode = "none"
      let baseframe = gesture.view.frame
      let locationToBrowser = gesture.locationInView(self.view)
      let frame = self.view.frame
      let height = locationToBrowser.y+baseframe.height*0.5
      if (height <= 100) {
        height = 100
      }
      //  self.view.frame = {x:frame.x,y:frame.y,width:frame.width+translationX,height:frame.height+translationY}
      self.view.frame = {x:50,y:50,width:400,height:height}
      self.currentFrame  = self.view.frame
    }else{
      self.custom = false;
      self.dynamic = false;
      self.customMode = "none"
      let baseframe = gesture.view.frame
      let locationToBrowser = gesture.locationInView(self.view)
      let frame = self.view.frame
      let height = locationToBrowser.y+baseframe.height*0.5
      if (height <= 120) {
        height = 120
      }
      //  self.view.frame = {x:frame.x,y:frame.y,width:frame.width+translationX,height:frame.height+translationY}
      self.view.frame = {x:frame.x,y:50,width:400,height:height}
      self.currentFrame  = self.view.frame
    }

  },
  textViewDidBeginEditing:function (textview) {
    // showHUD("begin")
    self.notifyTimer.invalidate()
  },
  onPromptButton:async function (sender) {
  try {
    
    let self = getDynamicController()
    let title = sender.id
    let text = self.textSelected
    self.notifyController.noteid = self.noteId
    self.notifyController.text = text
    self.notifyController.currentPrompt = title
    let question
    if (self.noteId) {
      question = await self.addonController.getQuestionOnNote(self.noteId,title)
    }else{
      question = await self.addonController.getQuestionOnText(text,title)
    }
    if (!question) {
      return
    }
    // copyJSON(question)
    // let config = self.addonController.config
    self.notifyController.query = text
    // copyJSON(question)
    self.notifyController.ask(question)
    } catch (error) {
    showHUD("Error in onPromptButton: "+error)
  }
  }
});
/**
 * @this {dynamicController}
 */
dynamicController.prototype.init = function () {
    if (this.firstFrame) {
      this.view.frame = this.firstFrame
    }else{
      this.view.frame = genFrame(50, 50, 40, 40)
    }

    this.lastFrame = this.view.frame;
    this.view.layer.shadowOffset = {width: 0, height: 0};
    this.view.layer.shadowRadius = 15;
    this.view.layer.shadowOpacity = 0.5;
    this.view.layer.shadowColor = UIColor.colorWithWhiteAlpha(0.5, 1);
    this.view.layer.cornerRadius = 11
    this.view.layer.borderColor = hexColorAlpha("#9bb2d6",0.8)
    this.view.layer.borderWidth = 0
    this.view.backgroundColor = hexColorAlpha("#ffffff",0.55)

    this.scrollview = UIScrollView.new()
    this.view.addSubview(this.scrollview)
    this.scrollview.hidden = true
    this.scrollview.delegate = this
    this.scrollview.bounces = true
    this.scrollview.opacity = 1.0
    this.scrollview.alwaysBounceVertical = true
    this.scrollview.layer.cornerRadius = 8
    this.scrollview.backgroundColor = hexColorAlpha("#c0bfbf",0.55)
  this.gobackImage = getImage(this.mainPath + `/goback.png`)
  this.homeImage = getImage(this.mainPath + `/home.png`)
  this.goforwardImage = getImage(this.mainPath + `/goforward.png`)
  this.reloadImage = getImage(this.mainPath + `/reload.png`)
  this.stopImage = getImage(this.mainPath + `/stop.png`)
  this.screenImage = getImage(this.mainPath + `/screen.png`)
  this.bigbangImage = getImage(this.mainPath + `/bigbang.png`)
  this.copyImage = getImage(this.mainPath + `/copy.png`)
  this.titleImage = getImage(this.mainPath + `/title.png`)
  this.tagImage = getImage(this.mainPath + `/tag.png`)
  this.commentImage = getImage(this.mainPath + `/comment.png`)
  this.aiImage = getImage(this.mainPath + `/ai.png`, 3)
  this.aiLinkImage = getImage(this.mainPath + `/aiLink.png`)
  this.chatImage = getImage(this.mainPath + `/chat.png`)
  this.sendImage = getImage(this.mainPath + `/send.png`)
  this.lockImage = getImage(this.mainPath + `/lock.png`)
  this.unlockImage = getImage(this.mainPath + `/unlock.png`)
  this.ocrImage = getImage(this.mainPath + `/ocr.png`)

  this.aiButton = this.createButton("openInput:")
  this.aiButton.setImageForState(this.aiImage,0)
  this.aiButton.hidden = false
  this.aiButton.frame = genFrame(0, 0, 40, 40)
  this.aiButton.backgroundColor = hexColorAlpha("#ffffff",0)

  this.closeButton = this.createButton("closeInput:")
  this.closeButton.setImageForState(this.stopImage,0)
  this.closeButton.hidden = true
  this.closeButton.backgroundColor = hexColorAlpha("#e06c75",0.8)

  this.sendButton = this.createButton("askWithPrompt:")
  this.sendButton.setImageForState(this.sendImage,0)
  this.sendButton.hidden = true
  this.sendButton.backgroundColor = hexColorAlpha("#e06c75",0.8)
  this.promptInput = this.creatTextView("view","#89a6d5",0.75)
  this.promptInput.hidden = true

  this.OCREnhanced = this.createButton("toggleOCREnhanceMode:")
  this.OCREnhanced.setImageForState(this.ocrImage,0)
  this.OCREnhanced.hidden = true
  this.OCREnhanced.backgroundColor = hexColorAlpha("#c0bfbf",0.8)

  this.moveGesture = new UIPanGestureRecognizer(this,"onMoveGesture:")
  this.closeButton.addGestureRecognizer(this.moveGesture)
  this.moveGesture.view.hidden = false
  this.moveGesture.addTargetAction(this,"onMoveGesture:")
  this.moveGesture1 = new UIPanGestureRecognizer(this,"onMoveGesture:")
  this.sendButton.addGestureRecognizer(this.moveGesture1)
  this.moveGesture1.view.hidden = false
  this.moveGesture1.addTargetAction(this,"onMoveGesture:")
}

dynamicController.prototype.createButton = function (targetAction,superview,) {
  /** @type {UIButton} */
  let button = UIButton.buttonWithType(0);
  button.autoresizingMask = (1 << 0 | 1 << 3);
  button.setTitleColorForState(UIColor.whiteColor(),0);
  button.setTitleColorForState(this.highlightColor, 1);
  button.backgroundColor = hexColorAlpha("#89a6d5",1.0)
  // button.backgroundColor = hexColorAlpha("#4769a0",1.0)
  button.layer.cornerRadius = 8;
  button.layer.masksToBounds = true;
  button.titleLabel.font = UIFont.systemFontOfSize(16);
  if (targetAction) {
    button.addTargetActionForControlEvents(this, targetAction, 1 << 6);
  }
  if (superview) {
    this[superview].addSubview(button)
  }else{
    this.view.addSubview(button);
  }
  return button
}

/**
 * @this {dynamicController}
 */
dynamicController.prototype.setLayout = function (frame) {
  studyController().view.bringSubviewToFront(this.view)
  this.view.frame = frame
  this.lastFrame = frame
  // this.aiButton.frame = genFrame(0, 0, 40, 40)
  // this.closeButton.frame = genFrame(5, 5, 35, 35)
  // this.sendButton.frame = genFrame(260, 5, 35, 35)
  // this.promptInput.frame = genFrame(45, 5, 210, 35)
  // this.scrollview.frame = genFrame(5, 45, 290, 150)
  if (frame.width === 40) {
    this.closeButton.hidden = true
    this.sendButton.hidden = true
    this.OCREnhanced.hidden = true
    this.promptInput.hidden = true
    this.scrollview.hidden = true
    this.aiButton.hidden = false
  }else{
    this.closeButton.hidden = false
    this.sendButton.hidden = false
    this.OCREnhanced.hidden = false
    this.promptInput.hidden = false
    this.scrollview.hidden = false
    if (this.OCREnhancedMode) {
      this.OCREnhanced.backgroundColor = hexColorAlpha("#e06c75",0.8)
    }else{
      this.OCREnhanced.backgroundColor = hexColorAlpha("#c0bfbf",0.8)
    }
    try {
      
    this.setButtonText(this.addonController.config.promptNames)
    } catch (error) {
      showHUD("Error in setLayout: "+error)
    }
  }
}

/**
 * @this {dynamicController}
 * @returns {UITextView}
 */
dynamicController.prototype.creatTextView = function (superview="view",color="#c0bfbf",alpha=0.9) {
  /** @type {UITextView} */
  let view = UITextView.new()
  view.font = UIFont.systemFontOfSize(15);
  view.layer.cornerRadius = 8
  view.backgroundColor = hexColorAlpha(color,alpha)
  view.textColor = UIColor.blackColor()
  view.delegate = this
  view.bounces = true
  this[superview].addSubview(view)
  return view
}


/**
 * @this {dynamicController}
 */
dynamicController.prototype.setButtonText = function (names) {
    this.words = names

    names.map((word,index)=>{
      if (!this["nameButton"+index]) {
        this["nameButton"+index] = this.createButton("onPromptButton:","scrollview")
        // this.createButton("nameButton"+index,"onPromptButton:","scrollview")
        this["nameButton"+index].titleLabel.font = UIFont.systemFontOfSize(16);
      }
      this["nameButton"+index].hidden = false
      this["nameButton"+index].setTitleForState(this.addonController.prompts[word].title,0) 
      this["nameButton"+index].id = word
      this["nameButton"+index].backgroundColor = hexColorAlpha("#89a6d5",0.8);
      this["nameButton"+index].isSelected = false
    })
    this.refreshLayout()
}

/**
 * @this {dynamicController}
 */
dynamicController.prototype.refreshLayout = function () {
    var viewFrame = this.scrollview.bounds;
    var xLeft     = 0
    let initX = 10
    let initY = 10
    let initL = 0
    this.locs = [];
    this.words.map((word,index)=>{
      let title = this.addonController.prompts[word].title
      let width = strCode(title.replaceAll(" ",""))*9+15
      if (xLeft+initX+width > viewFrame.width-10) {
        initX = 10
        initY = initY+40
        initL = initL+1
      }
      this["nameButton"+index].frame = {  x: xLeft+initX,  y: initY,  width: width,  height: 30,};
      this.locs.push({
        x:xLeft+initX,
        y:initY,
        l:initL,
        i:index
      })
      initX = initX+width+10
    })
    if (this.lastLength && this.lastLength>this.words.length) {
      for (let index = this.words.length; index < this.lastLength; index++) {
        this["nameButton"+index].hidden = true
      }
    }
    this.lastLength = this.words.length
    this.scrollview.contentSize= {width:viewFrame.width,height:initY+40}
  
}
/**
 * @this {dynamicController}
 */
dynamicController.prototype.getTextForSearch = function (note,OCR_enabled=false) {
    let order = this.addonController.config.searchOrder
    let text
    for (let index = 0; index < order.length; index++) {
      const element = order[index];
      switch (element) {
        case 1:
          if (note.noteTitle && note.noteTitle !== "") {
            text = note.noteTitle
          }
          break;
        case 2:
          if (OCR_enabled && note.excerptPic && !note.textFirst) {
            let image = getMediaByHash(note.excerptPic.paint)
            text = this.addonController.getTextOCR(image)
          }else if (noteHasExcerptText(note)) {
            text = note.excerptText
          }
          //如果都不满足，此时text依然为undefined
          break;
        case 3:
          let commentText
          //用find主要是保证得到想要的元素之后就会直接返回，而不是继续执行
          let comment = note.comments.find(comment=>{
            switch (comment.type) {
              case "TextNote":
                if (/^marginnote3app:\/\//.test(comment.text)) {
                  return false
                }else{
                  commentText = comment.text
                  return true
                }
              case "HtmlNote":
                commentText = comment.text
                return true
              case "LinkNote":
                if (OCR_enabled && comment.q_hpic && !note.textFirst) {
                  let commentImage = getMediaByHash(comment.q_hpic.paint)
                  commentText = this.addonController.getTextOCR(commentImage)
                  return true
                }else{
                  commentText = comment.q_htext
                  return true
                }
              case "PaintNote":
                if (OCR_enabled && comment.paint) {
                  let commentImage = getMediaByHash(comment.paint)
                  commentText = this.addonController.getTextOCR(commentImage)
                  return true
                }
                return false
              default:
                return false
            }
          })
          // let noteText  = note.comments.filter(comment=>comment.type === "TextNote" && !/^marginnote3app:\/\//.test(comment.text))
          // if (noteText.length) {
          //   text =  noteText[0].text
          // }
          if (commentText && commentText.length) {
            text = commentText
          }
          break;
        default:
          break;
      }
      if (text) {
        return text
      }
    }
  return undefined
  }

/**
 * @this {dynamicController}
 */
dynamicController.prototype.getItemFromNoteByOrder = function (note) {
    let order = this.addonController.config.searchOrder
    let text
    for (let index = 0; index < order.length; index++) {
      const element = order[index];
      switch (element) {
        case 1:
          if (note.noteTitle && note.noteTitle !== "") {
            text = note.noteTitle
          }
          break;
        case 2:
          if (note.excerptText && note.excerptText !== "" && (!note.excerptPic || note.textFirst)) {
            text = note.excerptText
          }
          break;
        case 3:
          let commentText
          let comment = note.comments.find(comment=>{
            switch (comment.type) {
              case "TextNote":
                if (/^marginnote3app:\/\//.test(comment.text)) {
                  return false
                }else{
                  commentText = comment.text
                  return true
                }
              case "HtmlNote":
                commentText = comment.text
                return true
              case "LinkNote":
                if (comment.q_hpic && !note.textFirst) {
                  return false
                }else{
                  commentText = comment.q_htext
                  return true
                }
              default:
                return false
            }
          })
          // let noteText  = note.comments.filter(comment=>comment.type === "TextNote" && !/^marginnote3app:\/\//.test(comment.text))
          // if (noteText.length) {
          //   text =  noteText[0].text
          // }
          if (commentText && commentText.length) {
            text = commentText
          }
          break;
        default:
          break;
      }
      if (text) {
        return text
      }
    }
  return ""
  }
/**
 * @this {dynamicController}
 */
dynamicController.prototype.getImageForOCR = function (noteId,userChoice,prompt) {
  //用户没手动开启，自然为false
  if (!userChoice) {
    return undefined
  }
  if (noteId) {
    let note = getNoteById(noteId)
  }
  let contextHasOCR = prompt.context.includes("{{textOCR}}")
  let systemHasOCR = prompt.system && prompt.system.includes("{{textOCR}}")
  let contextHasContext = prompt.context.includes("{{context}}")
  let systemHasContext = prompt.system && prompt.system.includes("{{context}}")

  if (contextHasOCR || systemHasOCR) {
    return undefined
  }
  if (!contextHasContext && !systemHasContext) {
    return undefined
  }

  let image = docController().imageFromSelection()
  if (!image) {
    // let docFocusNote = docController().focusNote
    // if (docFocusNote) {
      image = docController().imageFromFocusNote()
    // }
  }
  return image


}

/**
 * @this {dynamicController}
 */
dynamicController.prototype.askWithPromptOnText = async function (text) {
  try {
  let userInput = this.promptInput.text
  let defaultDynamicPrompt = {
    "note":"list below is the structure of a card:\n{{card}}",
    "text":"{{context}}"
  }
  let dynamicPrompt = getLocalDataByKeyDefault("MNChatglm_dynamicPrompt", defaultDynamicPrompt)
  let system = dynamicPrompt.text
  let systemMessage = await this.addonController.getTextVarInfo(system,this.OCREnhancedMode)
  // copy(systemMessage)
  let question = [{role:"system",content:systemMessage},{role: "user", content: userInput}]
  // copyJSON(question)
  this.notifyController.askByDynamic(question)
  this.notifyController.currentPrompt = "Dynamic"
  this.notifyController.noteid = undefined
    } catch (error) {
    showHUD(error)
  }
}

/**
 * @this {dynamicController}
 */
dynamicController.prototype.askWithPromptOnNote = async function (noteid) {
  try {
  let userInput = this.promptInput.text
  let defaultDynamicPrompt = {
    "note":"list below is the structure of a card:\n{{card}}",
    "text":"{{context}}"
  }
  let dynamicPrompt = getLocalDataByKeyDefault("MNChatglm_dynamicPrompt", defaultDynamicPrompt)
  let system = dynamicPrompt.note
  let systemMessage = await this.addonController.getNoteVarInfo(noteid, system,this.OCREnhancedMode)
  if (systemMessage === undefined) {
    return
  }
  let question = [{role:"system",content:systemMessage},{role: "user", content: userInput}]
  // copyJSON(question)
  this.notifyController.askByDynamic(question)
  this.notifyController.currentPrompt = "Dynamic"
  this.notifyController.noteid = this.noteId
    } catch (error) {
    showHUD(error)
  }
}
/**
 * @type {UIView}
 */
dynamicController.prototype.view

/**
 * @type {chatglmController}
 */
dynamicController.prototype.addonController

/**
 * @type {notificationController}
 */
dynamicController.prototype.notifyController