
JSB.newAddon = function (mainPath) {

  JSB.require('webviewController');
  JSB.require('notificationController')
  JSB.require('dynamicController')
  JSB.require('utils')
  /** @return {MNChatglmClass} */
  const getMNChatglmClass = ()=>self  
    // NSUserDefaults.standardUserDefaults().removeObjectForKey("MNChatglm_config")
    // NSUserDefaults.standardUserDefaults().removeObjectForKey("MNChatglm_promptNames")
    // NSUserDefaults.standardUserDefaults().removeObjectForKey('MNChatglm_currentPrompt');
    // NSUserDefaults.standardUserDefaults().removeObjectForKey('MNChatglm_toolbar');
    // NSUserDefaults.standardUserDefaults().removeObjectForKey('MNChatglm_onNewExcerpt');
    // NSUserDefaults.standardUserDefaults().removeObjectForKey('MNChatglm_dynamic');

  let defaultPrompts = {
      Translate:                      {title: "翻译",context:"请翻译下面这段话：{{context}}"},
      Keyword:                        {title: "关键词",context:"请为下面这段话提取关键词：{{context}}"},
      Title:                          {title: "标题",context:"请为下面这段话生成标题：{{context}}"}
  }
  let prompts = getLocalDataByKeyDefault('MNChatglm_prompts',defaultPrompts)
  // let prompts = defaultPrompts
  let knowledge = getLocalDataByKeyDefault('MNChatglm_knowledge',"")
  let keys = getLocalDataByKeyDefault('MNChatglm_builtInKeys', {})
  let config = getConfig()
  let currentPrompt = config.currentPrompt
  let onNewExcerpt = config.onNewExcerpt
  let toolbar = config.toolbar
  let observers = []
  // var temSender;

  var MNChatglmClass = JSB.defineClass(
    'MNChatglm : JSExtension',
    { /* Instance members */
      sceneWillConnect: function () { //Window initialize
        self.isNewWindow = false;
        self.watchMode = false;
        self.textSelected = ""
        self.textProcessed = false;
        self.dateGetText = Date.now();
        self.dateNow = Date.now();
        self.rect = '{{0, 0}, {10, 10}}';
        self.arrow = 1;
        self.isFirst = true;
        self.linkDetected = false
        addObserver(self, 'onPopupMenuOnSelection:', 'PopupMenuOnSelection')
        addObserver(self, 'onPopupMenuOnNote:', 'PopupMenuOnNote')
        addObserver(self, 'onClosePopupMenuOnNote:', 'ClosePopupMenuOnNote')
        addObserver(self, 'onClosePopupMenuOnSelection:', 'ClosePopupMenuOnSelection')
        addObserver(self, 'onProcessNewExcerpt:', 'ProcessNewExcerpt')
        addObserver(self, 'onChatOnNote:', 'chatOnNote')
        addObserver(self, 'onChatOnQuestion:', 'chatOnQuestion')
      },

      sceneDidDisconnect: function () { // Window disconnect

      },

      sceneWillResignActive: function () { // Window resign active
      },

      sceneDidBecomeActive: function () { // Window become active
      },

      notebookWillOpen: function (notebookid) {
      try {
        

        let self = getMNChatglmClass()
        self.appInstance = Application.sharedInstance();
        self.studyController = Application.sharedInstance().studyController(self.window)
        // self.addonController = browserController.new();
        if (!self.addonController) {
          self.addonController = chatglmController.new();
          self.addonController.keys = keys
        }
        self.addonController.mainPath = mainPath;
        self.addonController.config = config
        self.addonController.prompts = prompts;
        self.addonController.knowledge = knowledge
        if (!self.addSubview) {
          self.addSubview = true
          studyController().view.addSubview(self.addonController.view);
        }
        if (!self.notifyController) {
          self.notifyController = notificationController.new();
          self.notifyController.mainPath = mainPath;
          self.notifyController.config = self.addonController.config
          self.studyController.view.addSubview(self.notifyController.view);
          self.notifyController.view.hidden = true
          self.notifyController.view.frame = {x:50,y:50,width:400,height:120}
          self.notifyController.currentFrame = {x:50,y:50,width:400,height:120}
          self.notifyController.addonController = self.addonController
          self.addonController.notifyController = self.notifyController
          // self.notifyController.show(0)
        }

        self.studyController.refreshAddonCommands();
        self.addonController.view.hidden = true;
        self.addonController.notebookid = notebookid

        if (self.addonController.promptNames.includes(config.currentPrompt)) {
          self.addonController.currentPrompt = currentPrompt
        }
        NSTimer.scheduledTimerWithTimeInterval(0.2, false, function () {
          self.studyController(self.window).becomeFirstResponder(); //For dismiss keyboard on iOS
        });
      } catch (error) {
        
      }
      },
      notebookWillClose: function (notebookid) {
        // self.addonController.homePage()
        self.addonController.view.removeFromSuperview()
        // self.appInstance.studyController(self.window).view.remov(self.addonController.view);
        self.watchMode = false;
        self.addSubview = false;
        self.textSelected = '';
        if (self.notifyController.connection) {
          self.notifyController.connection.cancel()
          delete self.notifyController.connection
        }
        // removeObservers(self,['PopupMenuOnSelection','ClosePopupMenuOnSelection','PopupMenuOnNote','ClosePopupMenuOnNote'])
      },

      documentDidOpen: function (docmd5) {
      },

      documentWillClose: function (docmd5) {
      },

      controllerWillLayoutSubviews: function (controller) {
        if (controller !== self.appInstance.studyController(self.window)) {
          return;
        };
        if (!self.addonController.view.hidden) {
          let studyFrame = Application.sharedInstance().studyController(self.window).view.bounds
          if (self.addonController.miniMode) {
            let oldFrame = self.addonController.view.frame
            if (oldFrame.x < studyFrame.width*0.5) {
            // self.addonController.view.frame = self.addonController.currentFrame
              self.addonController.view.frame = { x: 0, y: oldFrame.y, width: 40, height: 40 }
            } else {
              self.addonController.view.frame = { x: studyFrame.width - 40, y: oldFrame.y, width: 40, height: 40 }
            }
          } else if (self.addonController.custom) {
            self.addonController.setSplitScreenFrame(self.addonController.customMode)
          }else{
            let currentFrame = self.addonController.currentFrame
            if (currentFrame.x+currentFrame.width*0.5 >= studyFrame.width) {
              currentFrame.x = studyFrame.width-currentFrame.width*0.5              
            }
            if (currentFrame.y >= studyFrame.height) {
              currentFrame.y = studyFrame.height-20              
            }
            self.addonController.view.frame = currentFrame
            self.addonController.currentFrame = currentFrame
          }
        }
        if (!self.notifyController.view.hidden) {
          let currentFrame = self.notifyController.currentFrame
          self.notifyController.view.frame = currentFrame
          
        }
      },

      queryAddonCommandStatus: function () {
        return {
          image: 'logo.png',
          object: self,
          selector: 'toggleAddon:',
          checked: self.addonController.config.autoAction
        };
      },

      onPopupMenuOnSelection: function (sender) { // Selecting text on pdf or epub
        let self = getMNChatglmClass()
        if (!self.appInstance.checkNotifySenderInWindow(sender, self.window)) return; // Don't process message from other window
        self.textSelected = sender.userInfo.documentController.selectionText;

        self.addonController.selectedText = self.textSelected
        self.dateGetText = Date.now();
        self.textProcessed = false
        self.onPopupMenuOnSelectionTime = Date.now()
        let studyFrame = studyController().view.frame
        let winFrame = parseWinRect(sender.userInfo.winRect)
        let xOffset = sender.userInfo.arrow===1 ? 20: -50
        let yOffset = sender.userInfo.arrow===1 ? -50: -40
        winFrame.x = winFrame.x+xOffset-studyFrame.x
        winFrame.y = winFrame.y+yOffset
        if (winFrame.x < 0) {
          winFrame.x = 0
        }
        if (winFrame.x > studyFrame.width-40) {
          winFrame.x = studyFrame.width-40
        }
        let dynamicFrame = genFrame(winFrame.x, winFrame.y, 40, 40)
        self.checkDynamicController(dynamicFrame)
        self.notifyController.notShow = false
        self.dynamicController.noteId = undefined
        self.addonController.currentNoteId = undefined
        self.dynamicController.textSelected = self.textSelected
        if (!self.checkShouldProceed(self.textSelected,-1,"onSelection")) {
          return
        }
        self.notifyController.noteid = undefined
        self.addonController.ask(self.textSelected)
        if (self.viewTimer) self.viewTimer.invalidate();
      },
      onClosePopupMenuOnSelection: function (sender) {
        let self = getMNChatglmClass()
        if (!self.appInstance.checkNotifySenderInWindow(sender, self.window)) return; // Don't process message from other window

        self.onClosePopupMenuOnSelectionTime = Date.now()
        if (self.onClosePopupMenuOnSelectionTime>self.onPopupMenuOnSelectionTime+300 && !self.dynamicController.onClick) {
          let preOpacity = self.dynamicController.view.layer.opacity
          animateWithCompletion(()=>{
            self.dynamicController.view.layer.opacity = 0
          }, ()=>{
            self.dynamicController.view.layer.opacity = preOpacity
            self.dynamicController.view.hidden = true
          })
          return
        }
      },
      onProcessNewExcerpt: function (sender) {
        let self = getMNChatglmClass()
        if (!self.appInstance.checkNotifySenderInWindow(sender, self.window)) return; // Don't process message from other window
      try {
        

        let note = Database.sharedInstance().getNoteById(sender.userInfo.noteid)
        let currentNoteId = note.noteId
        self.notShow = false
        self.noteid = currentNoteId
        if (note.excerptPic) {
          return
        }

        let text = self.getTextForSearch(note)
        self.textSelected = text
        // self.textSelected = encodeURIComponent(note.excerptText ?? note.noteTitle.replaceAll('/', '\\/'))
        self.addonController.selectedText = self.textSelected
        self.addonController.currentNoteId = currentNoteId
        self.dateGetText = Date.now();
        self.textProcessed = false
        temSender = sender
        if (self.viewTimer) self.viewTimer.invalidate();
        if (!self.checkShouldProceed(self.textSelected,note.colorIndex,"onNewExcerpt")) {
          return
        }
        self.notifyController.noteid = currentNoteId
        self.addonController.ask(self.textSelected)
      } catch (error) {
        showHUD(error)
      }
      },
      onPopupMenuOnNote: function (sender) { // Clicking note
        let self = getMNChatglmClass()

        if (!self.appInstance.checkNotifySenderInWindow(sender, self.window)) return; // Don't process message from other window
        let note = sender.userInfo.note
        let currentNoteId = note.noteId
        self.noteid = currentNoteId
        self.onPopupMenuOnNoteTime = Date.now()
      try {
        let studyFrame = studyController().view.frame
        let winFrame = parseWinRect(sender.userInfo.winRect)
        let yOffset = winFrame.width===10?50:25
        let xOffset = winFrame.width===10?winFrame.width+20:winFrame.width
        let dynamicFrame = genFrame(winFrame.x+xOffset-studyFrame.x, winFrame.y-yOffset, 40, 40)
        if (dynamicFrame.y < 10) {
          dynamicFrame.y = 10
        }
        if (dynamicFrame.x > studyFrame.width-40) {
          dynamicFrame.x = studyFrame.width-40
        }
        self.checkDynamicController(dynamicFrame)
        self.notifyController.notShow = false
        self.dynamicController.noteId = currentNoteId
        self.addonController.currentNoteId = currentNoteId
        // showHUD(currentNoteId)

        let text = self.getTextForSearch(note)
        self.textSelected = text
        self.addonController.selectedText = self.textSelected
        if (!text) {
          return
        }
        self.dateGetText = Date.now();
        self.textProcessed = false
        temSender = sender
        if (self.viewTimer) self.viewTimer.invalidate();
        if (!self.checkShouldProceed(self.textSelected,note.colorIndex+16,"onNote")) {
          return
        }
        self.currentTime = Date.now()
        self.notifyController.noteid = sender.userInfo.note.noteId
        if (!self.notifyController.view.hidden && self.lastQuestion == question) {
          return
        }
        self.lastQuestion = self.addonController.ask(text)
      } catch (error) {
        showHUD("Error in onPopupMenuOnNote: "+error)
      }
      },
      onClosePopupMenuOnNote: function (sender) {
        let self = getMNChatglmClass()
        if (!self.appInstance.checkNotifySenderInWindow(sender, self.window)) return; // Don't process message from other window
        if (self.noteid === sender.userInfo.noteid && Date.now()-self.dateGetText < 500) {
          self.notifyController.notShow = true
        }

        self.onClosePopupMenuOnNoteTime = Date.now()
        if (self.noteid === sender.userInfo.noteid && Date.now()-self.onPopupMenuOnNoteTime < 500) {
          self.notShow = true
        }
        if (self.onClosePopupMenuOnNoteTime>self.onPopupMenuOnNoteTime+300 && !self.dynamicController.onClick) {
          let preOpacity = self.dynamicController.view.layer.opacity
          animateWithCompletion(()=>{
            self.dynamicController.view.layer.opacity = 0
          }, ()=>{
            self.dynamicController.view.layer.opacity = preOpacity
            self.dynamicController.view.hidden = true
          })
          return
        }
      },
      onChatOnNote: function (sender) { // Clicking note
        let self = getMNChatglmClass()
  // if (!self.response) {
  //   self.response = ""
  // }
  // self.response = self.response+"time:"+Date.now()
  // copy(self.response)
        if (self.window!==self.appInstance.focusWindow) {
          return
        }
        if (self.notifyController.onChat) {
          return
        }
      try {
        self.notifyController.notShow = false
        self.notifyController.called = true
        let note = getNoteById(sender.userInfo.noteid)
        let currentNoteId = note.noteId
        self.noteid = currentNoteId
        let text = self.getTextForSearch(note)
        if (!text) {
          return
        }
        self.textSelected = text
        // self.textSelected = encodeURIComponent(note.excerptText ?? note.noteTitle.replaceAll('/', '\\/'))
        self.addonController.selectedText = self.textSelected
        self.addonController.currentNoteId = currentNoteId
        self.dateGetText = Date.now();
        self.textProcessed = false
        temSender = sender
        if (self.viewTimer) self.viewTimer.invalidate();
        if (!self.addonController.view.window) return;
        // self.currentTime = Date.now()
        self.notifyController.noteid = note.noteId
        self.notifyController.notifyLoc = self.addonController.notifyLoc
        self.addonController.ask(text)
      } catch (error) {
        showHUD(error)
      }
      },
      onChatOnQuestion: function (sender) { // Clicking note
        if (self.window!==self.appInstance.focusWindow) {
          return
        }
      try {
        let self = getMNChatglmClass()
        self.notifyController.notShow = false
        self.notifyController.called = true
        let currentNoteId = undefined
        self.noteid = currentNoteId
        let question = sender.userInfo.question
        // self.textSelected = encodeURIComponent(note.excerptText ?? note.noteTitle.replaceAll('/', '\\/'))
        self.addonController.selectedText = self.textSelected
        self.addonController.currentNoteId = currentNoteId
        self.dateGetText = Date.now();
        self.textProcessed = false
        temSender = sender
        // Application.sharedInstance().showHUD(sender.userInfo.note,self.window,2)
        if (self.viewTimer) self.viewTimer.invalidate();
        if (!self.addonController.view.window) return;
        // self.currentTime = Date.now()
        self.notifyController.noteid = undefined
        if (sender.userInfo.model) {
          self.addonController.config.currentModel = sender.userInfo.model
        }else{
          self.addonController.config.currentModel = self.addonController.config.model
        }
        if (/{{knowledge}}/.test(question)) {
          let knowledge = self.addonController.knowledge
          if (knowledge && knowledge.trim() != "") {
            question = question.replace('{{knowledge}}',`
以及部分参考翻译
'''
${knowledge}
'''`)
          }else{
            question = question.replace('{{knowledge}}',``)
          }
        }
        // self.notifyController.textviewResponse.text = "I'm thinking..."
        self.notifyController.ask(question)
        self.notifyController.notifyLoc = self.addonController.notifyLoc
        // self.beginNotification()
      } catch (error) {
        showHUD(error)
      }
      },
      toggleAddon: function (sender) {
      // try {
        

        if (!self.addonBar) {
          self.addonBar = sender.superview.superview
          self.addonController.addonBar = self.addonBar
        }
        if (self.addonController.view.hidden) {
          if (self.isFirst) {
            // Application.sharedInstance().showHUD("first",self.window,2)
            let buttonFrame = self.addonBar.frame
            let width = 375
            if (buttonFrame.x === 0) {
              self.addonController.view.frame = {x:40,y:buttonFrame.y,width:width,height:550}
            }else{
              self.addonController.view.frame = {x:buttonFrame.x-width,y:buttonFrame.y,width:width,height:550}
            }
            self.addonController.currentFrame = self.addonController.view.frame
            self.isFirst = false;
          }
          self.addonController.show(self.addonBar.frame)
          if (!self.notifyController.view.hidden) {
            self.notifyController.hide()
            self.notifyController.notifyTimer.invalidate()
          }
          // self.addonController.view.hidden = false
        } else {
            // self.addonController.view.hidden = true;
          if (self.addonController.miniMode) {
            let preFrame = self.addonController.view.frame
            self.addonController.view.hidden = true
            self.addonController.showAllButton()
            let studyFrame = Application.sharedInstance().studyController(self.window).view.bounds
            if (self.addonController.view.frame.x < studyFrame.width*0.5) {
              self.addonController.lastFrame.x = 0
            }else{
              self.addonController.lastFrame.x = studyFrame.width-self.addonController.lastFrame.width
            }
            self.addonController.view.frame  = self.addonController.lastFrame
            self.addonController.currentFrame = self.addonController.lastFrame
            self.addonController.show(preFrame)
          }else{
            self.addonController.hide(self.addonBar.frame)
          }
          self.watchMode = false;
          self.appInstance.studyController(self.window).refreshAddonCommands();
          return;
        }
        NSTimer.scheduledTimerWithTimeInterval(0.2, false, function () {
          self.appInstance.studyController(self.window).becomeFirstResponder(); // For dismiss keyboard on iOS
        });

        if (!self.addonController.view.window) return;
        if (self.viewTimer) self.viewTimer.invalidate();
      // } catch (error) {
      //   showHUD(error)
      // }
      },
    },
    { /* Class members */
      addonDidConnect: function () {
      },

      addonWillDisconnect: function () {
        removeLocalDataByKey("MNChatglm_prompts")
        removeLocalDataByKey('MNChatglm_knowledge');
        removeLocalDataByKey('MNChatglm_config');
        removeLocalDataByKey("MNChatglm_fileId");
      },

      applicationWillEnterForeground: function () {
      },

      applicationDidEnterBackground: function () {
      },

      applicationDidReceiveLocalNotification: function (notify) {
      }
    }
  );

  MNChatglmClass.prototype.layoutAddonController = function (rectStr, arrowNum) {

    this.rect = rectStr || this.rect;
    this.arrow = arrowNum || this.arrow;
    var x, y
    w = (this.appInstance.osType !== 1) ? 419 : 365, // this.addonController.view.frame.width
      h = 500, // this.addonController.view.frame.height
      fontSize = 15,
      margin = 10,
      padding = 20,
      frame = this.appInstance.studyController(this.window).view.bounds,
      W = frame.width,
      H = frame.height,
      rectArr = this.rect.replace(/{/g, '').replace(/}/g, '').replace(/\s/g, '').split(','),
      X = Number(rectArr[0]),
      Y = Number(rectArr[1]),
      studyMode = this.appInstance.studyController(this.window).studyMode,
      contextMenuWidth = studyMode === 0 ? 225 : 435,
      contextMenuHeight = 35,
      textMenuPadding = 40;

    // this.addonController.view.frame.x
    if (w >= contextMenuWidth) {
      if (X - w / 2 - margin <= 0) {
        x = margin;
      } else if (X + w / 2 + margin >= W) {
        x = W - margin - w;
      } else {
        x = X - w / 2;
      }
    } else {
      if (X - contextMenuWidth / 2 - margin <= 0) {
        x = margin + contextMenuWidth / 2 - w / 2;
      } else if (X + contextMenuWidth / 2 + margin >= W) {
        x = W - margin - contextMenuWidth / 2 - w / 2;
      } else {
        x = X - w / 2;
      }
    }

    // this.addonController.view.frame.[y, height]
    if (this.arrow === 1) {
      let upperBlankHeight = Y - textMenuPadding - fontSize - padding,
        lowerBlankHeight = H - Y - contextMenuHeight - padding;
      if (upperBlankHeight >= lowerBlankHeight) {
        h = (upperBlankHeight >= h) ? h : upperBlankHeight;
        y = upperBlankHeight - h;
      } else {
        y = H - lowerBlankHeight;
        h = (H - y >= h) ? h : H - y;
    // this.appInstance.showHUD('x:'+x+';y:'+Y,this.window,2)
      }
    } else {
      let upperBlankHeight = Y - textMenuPadding - contextMenuHeight - padding,
        lowerBlankHeight = H - Y - fontSize - padding;
      if (upperBlankHeight >= lowerBlankHeight) {
        h = (upperBlankHeight >= h) ? h : upperBlankHeight;
        y = upperBlankHeight - h;
      } else {
        y = H - lowerBlankHeight;
        h = (H - y >= h) ? h : H - y;
      }
    }
    this.addonController.view.frame = { x: x, y: y, width: w, height: h };
    this.addonController.currentFrame = { x: x, y: y, width: w, height: h };

  };
  MNChatglmClass.prototype.customLayoutAddonController = function (rectStr, arrowNum, custom = false) {

    this.rect = rectStr || this.rect;
    this.arrow = arrowNum || this.arrow;
    var x, y
      w = (this.appInstance.osType !== 1) ? 419 : 365, // this.addonController.view.frame.width
      h = 450, // this.addonController.view.frame.height
      fontSize = 15,
      margin = 10,
      padding = 20,
      frame = this.appInstance.studyController(this.window).view.bounds,
      W = frame.width,
      H = frame.height,
      rectArr = this.rect.replace(/{/g, '').replace(/}/g, '').replace(/\s/g, '').split(','),
      X = Number(rectArr[0]),
      Y = Number(rectArr[1]),
      studyMode = this.appInstance.studyController(this.window).studyMode,
      contextMenuWidth = studyMode === 0 ? 225 : 435,
      contextMenuHeight = 35,
      textMenuPadding = 40;

    // this.addonController.view.frame.x
    if (w >= contextMenuWidth) {
      if (X - w / 2 - margin <= 0) {
        x = margin;
      } else if (X + w / 2 + margin >= W) {
        x = W - margin - w;
      } else {
        x = X - w / 2;
      }
    } else {
      if (X - contextMenuWidth / 2 - margin <= 0) {
        x = margin + contextMenuWidth / 2 - w / 2;
      } else if (X + contextMenuWidth / 2 + margin >= W) {
        x = W - margin - contextMenuWidth / 2 - w / 2;
      } else {
        x = X - w / 2;
      }
    }

    // this.addonController.view.frame.[y, height]
    if (this.arrow === 1) {
      let upperBlankHeight = Y - textMenuPadding - fontSize - padding,
        lowerBlankHeight = H - Y - contextMenuHeight - padding;
      if (upperBlankHeight >= lowerBlankHeight) {
        h = (upperBlankHeight >= h) ? h : upperBlankHeight;
        y = upperBlankHeight - h;
      } else {
        y = H - lowerBlankHeight;
        h = (H - y >= h) ? h : H - y;
      }
    } else {
      let upperBlankHeight = Y - textMenuPadding - contextMenuHeight - padding,
        lowerBlankHeight = H - Y - fontSize - padding;
      if (upperBlankHeight >= lowerBlankHeight) {
        h = (upperBlankHeight >= h) ? h : upperBlankHeight;
        y = upperBlankHeight - h;
      } else {
        y = H - lowerBlankHeight;
        h = (H - y >= h) ? h : H - y;
      }
    }
    this.addonController.view.frame = { x: x, y: y + 50, width: w, height: h };
    this.addonController.currentFrame = { x: x, y: y + 50 , width: w, height: h };
  };
  MNChatglmClass.prototype.getNoteList = function (note) {
    let noteList = []
    if (note.noteTitle) {
      noteList.push(note.noteTitle)
    }
    if (note.excerptText && !note.excerptPic) {
      noteList.push(note.excerptText)
    }
    return noteList.concat(note.comments.filter(comment=>comment.type="TextNote").map(comment=>comment.text))
  };
  MNChatglmClass.prototype.getTextForSearch = function (note) {
    let order = this.addonController.config.searchOrder
    // showHUD(order)
    let text = undefined
    for (let index = 0; index < order.length; index++) {
      const element = order[index];
      switch (element) {
        case 1:
          if (note.noteTitle && note.noteTitle !== "") {
            text = note.noteTitle
          }
          break;
        case 2:
          if (note.excerptText && note.excerptText !== "" && (!note.excerptPic || note.textFirst)) {
            text = note.excerptText
          }
          break;
        case 3:
          let commentText
          let comment = note.comments.find(comment=>{
            switch (comment.type) {
              case "TextNote":
                if (/^marginnote3app:\/\//.test(comment.text)) {
                  return false
                }else{
                  commentText = comment.text
                  return true
                }
              case "HtmlNote":
                commentText = comment.text
                return true
              case "LinkNote":
                if (comment.q_hpic && !note.textFirst) {
                  return false
                }else{
                  commentText = comment.q_htext
                  return true
                }
              default:
                return false
            }
          })
          // let noteText  = note.comments.filter(comment=>comment.type === "TextNote" && !/^marginnote3app:\/\//.test(comment.text))
          // if (noteText.length) {
          //   text =  noteText[0].text
          // }
          if (commentText && commentText.length) {
            // showHUD("comment")
            text = commentText
          }
          break;
        default:
          break;
      }
      if (text) {
        // showHUD(text)
        return text
      }
    }
  // showHUD("No text found")
  return ""
  }
  MNChatglmClass.prototype.beginNotification = function () {
    this.notifyController.notifyLoc = this.addonController.notifyLoc
    // let notifyController = this.notifyController
    // notifyController.textviewResponse.text = "I'm thinking..."
    // // showHUD("loc:"+notifyLoc)
    // if (notifyController.view.hidden || notifyController.notifyLoc !== notifyLoc) {
    //   notifyController.show(notifyLoc)
    // }
    // this.appInstance.studyController(this.window).view.bringSubviewToFront(notifyController.view)
    // if (notifyController.notifyTimer) {
    //   notifyController.notifyTimer.invalidate()
    // }
    // notifyController.notifyTimer = NSTimer.scheduledTimerWithTimeInterval(10, false, function () {
    //   notifyController.hide(notifyLoc)
    //   notifyController.notifyTimer.invalidate()
    // })
  }
  MNChatglmClass.prototype.checkShouldProceed = function (text,colorIndex = -1, param = "") {
    if (!this.addonController.view.window || !this.addonController.config.autoAction) {
      return false;
    }
    if (param !== "" && !this.addonController.config[param]) {
      return false
    }
    //聊天模式下禁用
    if (this.notifyController.onChat) {
      return false
    }
    if (!this.addonController.view.hidden) {
      //网页模式下不会使用API模式
      return false
    }
    //如果提供了颜色则根据颜色判断
    if (colorIndex !== -1 && !this.addonController.config.colorConfig[colorIndex]) {
      // showHUD("should prevent")
      return false
    }
    if (this.addonController.config.ignoreShortText && countWords(text) < 10) {
      return false
    }
    return true
  }
  /**
   * 
   * @param {*} dynamicFrame 
   * @this {MNChatglmClass}
   * @returns 
   */
  MNChatglmClass.prototype.checkDynamicController = function (dynamicFrame) {
    if (!this.dynamicController) {
      this.dynamicController = dynamicController.new();
      this.dynamicController.mainPath = mainPath;
      this.dynamicController.firstFrame = dynamicFrame
      studyController().view.addSubview(this.dynamicController.view);
      this.dynamicController.view.hidden  = false
      this.dynamicController.view.layer.opacity = 0
      this.dynamicController.addonController = this.addonController
      this.dynamicController.notifyController = this.notifyController
      this.addonController.dynamicController = this.dynamicController
    }
    if (!this.addonController.config.dynamic) {
      this.dynamicController.view.hidden = true
      return
    }
    if (this.dynamicController.pinned) {
      return
    }
    if (this.dynamicController.view.hidden) {
      this.dynamicController.view.layer.opacity = 0
      this.dynamicController.view.hidden = false
      this.dynamicController.setLayout(dynamicFrame)
    }
    this.dynamicController.onClick = false
    this.dynamicController.OCREnhancedMode = false
    animateWithCompletion(()=>{
      this.dynamicController.setLayout(dynamicFrame)
      this.dynamicController.view.layer.opacity = 1.0
    }, ()=>{
      this.dynamicController.view.hidden = false
    })
  }
  return MNChatglmClass;
};