


function genNSURL(url) {
  return NSURL.URLWithString(url)
}



/**
 * Ported version of Node Fetch, but with reduced features.
 */


function strCode(str) {  //获取字符串的字节数
    var count = 0;  //初始化字节数递加变量并获取字符串参数的字符个数
    var cn = [8211, 8212, 8216, 8217, 8220, 8221, 8230, 12289, 12290, 12296, 12297, 12298, 12299, 12300, 12301, 12302, 12303, 12304, 12305, 12308, 12309, 65281, 65288, 65289, 65292, 65294, 65306, 65307, 65311]
    var half = [32, 33, 34, 35, 36, 38, 39, 40, 41, 42, 43, 44, 45, 46, 47, 58, 59, 60, 61, 62, 63, 64, 91, 92, 93, 94, 95, 96, 123, 124, 125, 126,105,108,8211]
    if (str) {  //如果存在字符串，则执行
        len = str.length; 
        for (var i = 0; i < len; i++) {  //遍历字符串，枚举每个字符
          let charCode = str.charCodeAt(i)
            if (charCode>=65 && charCode<=90) {
              count += 1.5;  //大写
            } else if (half.includes(charCode)) {
              count +=0.45
            } else if (cn.includes(charCode)) {
              count +=0.8
            }else if (charCode > 255) {  //字符编码大于255，说明是双字节字符(即是中文)
                count += 2;  //则累加2个
            }else{
                count++;  //否则递加一次
            }
        }
        return count;  //返回字节数
    } else {
        return 0;  //如果参数为空，则返回0个
    }
}

function getSplitLine() {
    let studyFrame = Application.sharedInstance().studyController(this.window).view.bounds
    let readerFrame = Application.sharedInstance().studyController(this.window).readerController.view.frame
    let hidden = Application.sharedInstance().studyController(this.window).readerController.view.hidden//true代表脑图全屏
    let rightMode = Application.sharedInstance().studyController(this.window).rightMapMode
    let fullWindow = readerFrame.width == studyFrame.width
    if (hidden || fullWindow) {
      let splitLine = studyFrame.width*0.5
      return splitLine
    }
    if (rightMode) {
      let splitLine = readerFrame.x+readerFrame.width
      return splitLine
    }else{
      let splitLine = readerFrame.x
      return splitLine
    }
  }

function undoGroupingWithRefresh(notebookid,f){
  UndoManager.sharedInstance().undoGrouping(
    String(Date.now()),
    notebookid,
    f
  )
  Application.sharedInstance().refreshAfterDBChanged(notebookid)
}

function hexColorAlpha(hex,alpha=1.0) {
  let color = UIColor.colorWithHexString(hex)
  return alpha!==undefined?color.colorWithAlphaComponent(alpha):color
}

function genFrame(x,y,width,height) {
  return {x:x,y:y,width:width,height:height}
}

function getOrderText(order) {
  if (order[0] == 4) {
    return 'Order: (Title) + (Excerpt → Comment)'
  }
  let orderNumber = `${order[0]}${order[1]}${order[2]}`
  switch (orderNumber) {
    case "123":
      return 'Order: Title → Excerpt → Comment'
    case "132":
      return 'Order: Title → Comment → Excerpt'
    case "213":
      return 'Order: Excerpt → Title → Comment'
    case "231":
      return 'Order: Excerpt → Comment → Title'
    case "312":
      return 'Order: Comment → Title → Excerpt'
    case "321":
      return 'Order: Comment → Excerpt → Title'
    default:
      return "123";
  }
}

function shouldPrevent(currentURL,requestURL,type) {
  let firstCheck = Application.sharedInstance().osType === 0 && (type===0 || /^https:\/\/m.inftab.com/.test(currentURL))
  if (firstCheck) {
    let blacklist = ["^https?://www.bilibili.com","^https?://m.bilibili.com","^https?://space.bilibili.com","^https?://t.bilibili.com","^https?://www.wolai.com","^https?://flowus.com","^https?://www.notion.so"]
    if (blacklist.some(url=>RegExp(url).test(requestURL))) {
      return true
    }
  }
  return false
}

function showHUD(message,duration=2) {
  let focusWindow = Application.sharedInstance().focusWindow
  Application.sharedInstance().showHUD(message,focusWindow,2)
}


function postNotification(name,userInfo) {
  let focusWindow = Application.sharedInstance().focusWindow
  NSNotificationCenter.defaultCenter().postNotificationNameObjectUserInfo(name, focusWindow, userInfo)
  
}
/**
 * 
 * @param {String} text 
 * @returns 
 */
function getVars(text) {
  let vars = ["{{context}}","{{card}}","{{textOCR}}","{{currentDocInfo}}","{{noteDocInfo}}","{{knowledge}}"]
  let filteredVars = vars.filter(variable=>text.includes(variable));
  return filteredVars
}
function noteHasExcerptText(note) {
  //摘要文本必须存在并且不为空
  //考虑到可能存在图片摘要，因此要么图片摘要不存在，要么图片摘要已被转为文本
  return note.excerptText && note.excerptText !== "" && (!note.excerptPic || note.textFirst)
}
function getNoteById(noteid) {
  let note = Database.sharedInstance().getNoteById(noteid)
  return note
}

function getMediaByHash(hash) {
  let image = Database.sharedInstance().getMediaByHash(hash)
  return image
}

function getDocById(md5) {
  let doc = Database.sharedInstance().getDocumentById(md5)
  return doc
}

function getImage(path,scale=2) {
  return UIImage.imageWithDataScale(NSData.dataWithContentsOfFile(path), scale)
}

function setLocalDataByKey(value,key) {
  NSUserDefaults.standardUserDefaults().setObjectForKey(value,key)
  NSUserDefaults.standardUserDefaults().synchronize()
}

function getLocalDataByKey(key) {
  return NSUserDefaults.standardUserDefaults().objectForKey(key)
}

function removeLocalDataByKey(key) {
  NSUserDefaults.standardUserDefaults().removeObjectForKey(key)
}

function getLocalDataByKeyDefault(key,defaultValue) {
  let value = NSUserDefaults.standardUserDefaults().objectForKey(key)
  if (value === undefined) {
    NSUserDefaults.standardUserDefaults().setObjectForKey(defaultValue,key)
    return defaultValue
  }
  return value
}

function addObserver(object,target,notification) {
  NSNotificationCenter.defaultCenter().addObserverSelectorName(object, target, notification);
}
function removeObservers(object,notifications) {
  notifications.forEach(notification=>{
    NSNotificationCenter.defaultCenter().removeObserverName(object, notification);
  })
}

function getPopoverAndPresent(sender,commandTable,width=100) {
  var menuController = MenuController.new();
  menuController.commandTable = commandTable
  menuController.rowHeight = 35;
  menuController.preferredContentSize = {
    width: width,
    height: menuController.rowHeight * menuController.commandTable.length
  };
  var popoverController = new UIPopoverController(menuController);
  let focusWindow = Application.sharedInstance().focusWindow
  var studyController = Application.sharedInstance().studyController(focusWindow);
  var r = sender.convertRectToView(sender.bounds,studyController.view);
  popoverController.presentPopoverFromRect(r, studyController.view, 1 << 1, true);
  return popoverController
}
function copy(text) {
  UIPasteboard.generalPasteboard().string = text
}
function copyJSON(object) {
  UIPasteboard.generalPasteboard().string = JSON.stringify(object,null,2)
}
function countWords(str) {
    const chinese = Array.from(str)
        .filter(ch => /[\u4e00-\u9fa5]/.test(ch))
        .length
    
    const english = Array.from(str)
        .map(ch => /[a-zA-Z0-9\s]/.test(ch) ? ch : ' ')
        .join('').split(/\s+/).filter(s => s)
        .length

    return chinese + english
}
function studyController() {
  let focusWindow = Application.sharedInstance().focusWindow
  return Application.sharedInstance().studyController(focusWindow)
}
function docController() {
  let focusWindow = Application.sharedInstance().focusWindow
  return Application.sharedInstance().studyController(focusWindow).readerController.currentDocumentController
}
function documentFolder() {
  return Application.sharedInstance().documentPath
}

function getFile(path) {
  return NSData.dataWithContentsOfFile(path)
}
function sum(array) {
  let sum = 0
  for (let i = 0; i < array.length; i++) {
    sum = sum+array[i]
  }
  return sum
}

function getRandomElement(arr) {
  if (arr.length === 1) {
    return arr[0]
  }
  if (arr && arr.length) {
    const randomIndex = Math.floor(Math.random() * arr.length);
    return arr[randomIndex];
  }
  return ""; // 或者抛出一个错误，如果数组为空或者未定义
}

function getToday() {
  // 创建一个新的Date对象，默认情况下它会包含当前日期和时间
  const today = new Date();

  // 获取日
  const day = today.getDate();
  return day
}

function getUsage() {
  let default_usage = {limit:100,day:getToday(),usage:0}
  let usage = getLocalDataByKeyDefault('MNChatglm_usage',default_usage)
  let today = getToday()
  usage.limit = 100
  if (today !== usage.day) {
    usage.usage = 0
    usage.day = today
  }
  return usage
}

function getConfig() {
  let defaultPrompts = {
      Translate:                      {title: "翻译",context:"请翻译下面这段话：{{context}}"},
      Keyword:                        {title: "关键词",context:"请为下面这段话提取关键词：{{context}}"},
      Title:                          {title: "标题",context:"请为下面这段话生成标题：{{context}}"}
  }
  let defaultConfig = {
    searchOrder: [2,1,3],
    autoAction: false,
    onSelection: true,
    onNote: true,
    onNewExcerpt: true,
    notifyLoc: 0,
    toolbar: true,
    model: 0,
    chatglmModel:0,
    promptNames: Object.keys(defaultPrompts),
    currentPrompt: Object.keys(defaultPrompts)[0],
    apikey: "",
    modelOnReAsk: -1,
    source: "ChatGLM",
    url: "https://api.openai.com",
    openaiKey: "",
    tunnel:0,
    moonshotKey : "",
    moonshotModel : 0
  }
  // return defaultConfig
  let config = getLocalDataByKeyDefault('MNChatglm_config',defaultConfig)
  if (!config.source) {
    config.source = "ChatGLM"
    config.url = "https://api.openai.com"
    config.openaiKey = ""
    config.tunnel = 0
  }
  if(config.chatglmModel === undefined){
    config.chatglmModel = 0
  }
  if (!config.moonshotKey) {
    config.moonshotKey = ""
    config.moonshotModel = 0
  }
  return config
}

function getModelNames(source) {
  switch (source) {
    case "ChatGLM":
      return ["glm-3-turbo","glm-4","glm-4v"]
    case "ChatGPT":
      return ["gpt-3.5-turbo","gpt-3.5-turbo-1106","gpt-3.5-turbo-1106","gpt-3.5-turbo-16k","gpt-4","gpt-4-32k","gpt-4-turbo-preview","gpt-4-1106-preview","gpt-4-0125-preview","gpt-4-vision-preview","gpt-4-all","glm-4","glm-4v","glm-3-turbo","claude-2","gemini-pro","gemini-pro-vision"]
    case "KimiChat":
      return ["moonshot-v1-8k","moonshot-v1-32k","moonshot-v1-128k"]
    default:
      break;
  }
}

function html(string,scrollToBottom=false) {
  if (scrollToBottom) {
    return `<!doctype html>
<html>
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0,minimum-scale=1.0, maximum-scale=1.0, user-scalable=no">
  <title>Marked.js</title>
  <style>
pre {
  background-color: rgb(214, 214, 214);
  border-radius: 5px;
  white-space: pre-wrap;
  padding: 5px;
  max-width: 400px;
  overflow-x: scroll;
  margin-top: 0;
  margin-bottom: 5px;
}
img {
  max-width: 385px;
}
</style>
</head>
<body>
${string}
<br>
<script>
window.scrollTo(0,document.body.scrollHeight);
    MathJax = {
        tex: {inlineMath: [['$', '$'], ['\\(', '\\)']]}
    };
</script>
<script id="MathJax-script" async src="https://cdn.jsdelivr.net/npm/mathjax@3/es5/tex-chtml.js"></script>
</body>
</html>`
  }
return `<!doctype html>
<html>
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0,minimum-scale=1.0, maximum-scale=1.0, user-scalable=no">
  <title>Marked.js</title>
  <style>
pre {
  background-color: rgb(214, 214, 214);
  border-radius: 5px;
  padding: 5px;
  max-width: 400px;
  overflow-x: scroll;
  margin-top: 0;
  margin-bottom: 5px;
}
img {
  max-width: 385px;
}
</style>
</head>
<body>
${string}
  <script>
    MathJax = {
        tex: {inlineMath: [['$', '$'], ['\\(', '\\)']]}
    };
  </script>
<script id="MathJax-script" async src="https://cdn.jsdelivr.net/npm/mathjax@3/es5/tex-chtml.js"></script>
</body>
</html>`
}

function isValidJSON(jsonString){
   try{
       var json = JSON.parse(jsonString);
       if (json && typeof json === "object") {
           return true;
       }
   }
   catch(e){
       return false;
   }
   return false;
}

function mergeWhitespace(str) {
    // 先将多个连续的换行符替换为单个换行符
    var tempStr = str.replace(/\n+/g, '\n');
    // 再将其它的空白符（除了换行符）替换为单个空格
    return tempStr.replace(/[\r\t\f\v ]+/g, ' ').trim();
}

function getValidJSON(text) {
  try {
    text = text.replace("}{",",")
  if (text.endsWith(':')) {
    text = text+'""}'
  }
  if (isValidJSON(text)) {
    return JSON.parse(text)
  }else if (isValidJSON(text+"\"}")){
    return JSON.parse(text+"\"}")
  }else if (isValidJSON(text+"}")){
    return JSON.parse(text+"}")
  }else if (!text.startsWith('{') && text.endsWith('}')){
    return JSON.parse("{"+text)
  }else{
    return undefined
  }
  } catch (error) {
    showHUD("Error in getValidJSON: "+error)
    copy(text)
    return undefined
  }
}

function getResList(originalText) {
  let res = originalText.split("data:")
  // copy(originalText)
  res.shift()
  res.pop()
  let resList = res.map(r=>JSON.parse(r).choices[0].delta)
  return resList
}

/**
 * 
 * @param {Array} resList 
 */
function checkToolCalls(resList) {
  return resList.some(res=>{
      if (res.tool_calls) {
        return true
      }
      return false
    })
}
function getToolCalls(func) {
  if (func[0].type === "function") {
    let funcName = func[0].function.name
    let arguments = JSON.parse(func[0].function.arguments)
    return{
      funcName:funcName,
      arguments:arguments,
    }
  }
  return undefined
}
function genStructure(name,arguments,description) {
  let funcStructure = {
    "name":name,
    "description":description,
    "parameters": {
      "type": "object",
      "properties": arguments,
      "required": Object.keys(arguments),
    }
  }
  return {"type":"function","function":funcStructure}
}

function genArgument(type,description) {
  return{ "type": type, "description": description }
}

function getFuncForAI(funcName) {
  let arguments = {}
  switch (funcName) {
    case "setTitle":
      arguments.title = genArgument("string", "title that should be set for this card, pure text only")
      return genStructure(funcName, arguments,
        "this function is used to set title for a card"
      )
    case "addComment":
      arguments.comment = genArgument("string", "comment that should be added for this card, pure text only")
      return genStructure(funcName, arguments,
        "this function is used to add a comment for a card"
      )
    case "addTag":
      arguments.tag = genArgument("string", "tag that should be added for this card, single word only")
      return genStructure(funcName, arguments,
        "this function is used to add a tag for a card"
      )
    case "copyMarkdownLink":
      arguments.title = genArgument("string", "title for markdown link")
      return genStructure(funcName, arguments,
        "this function can copy the card link in mardown format, just specify the title for this link"
      )
    case "copyCardURL":
      return genStructure(funcName, arguments,
        "this function can directly copy the card url, no argument is needed"
      )
    case "copyText":
      arguments.text = genArgument("string", "pure text that need to be copied")
      return genStructure(funcName, arguments,
        "this function can copy any pure text, but not card link"
      )
    case "close":
      return genStructure(funcName, arguments,
        "this function is used to end the coversation, no argument is needed"
      )
    default:
      break;
  }
}

function getFunByIndex(indices,isNote = true) {
  let func = ["setTitle","addComment","copyMarkdownLink","copyCardURL","copyText","close","addTag"]
  let disableForSelection = [true,true,true,true,false,false,true]
  if (isNote) {
    let funcStructures = indices.map(ind=>getFuncForAI(func[ind]))
    return funcStructures
  }else{
    let funcStructures = indices.filter(ind=>!disableForSelection[ind]).map(ind=>getFuncForAI(func[ind]))
    return funcStructures
  }
}

function animate(func,time = 0.2) {
  UIView.animateWithDurationAnimationsCompletion(time,func)
}

function animateWithCompletion(func,funcWhenCompleted,time = 0.2) {
  UIView.animateWithDurationAnimationsCompletion(time,func,funcWhenCompleted)
}

function parseWinRect(winRect) {
  let rectArr = winRect.replace(/{/g, '').replace(/}/g, '').replace(/\s/g, '').split(',')
  let X = Number(rectArr[0])
  let Y = Number(rectArr[1])
  let H = Number(rectArr[3])
  let W = Number(rectArr[2])
  return genFrame(X, Y, W, H)
}

function initFileRequest (url,options,purpose,fileName,fileData) {
  const request = NSMutableURLRequest.requestWithURL(genNSURL(url))
  try {
    

  request.setHTTPMethod("Post")
  request.setTimeoutInterval(options.timeout ?? 10)
  let boundary = NSUUID.UUID().UUIDString()

  const headers = {
    "User-Agent":
      "Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/13.1.1 Safari/605.1.15",
    "Content-Type": "multipart/form-data; boundary="+boundary,
    Accept: "application/json"
  }
  request.setAllHTTPHeaderFields({
    ...headers,
    ...(options.headers ?? {})
  })
  let body = NSMutableData.new()
  let purposeData = NSData.dataWithStringEncoding(purpose, "utf8")
  let purposePart = NSData.dataWithStringEncoding(`
--${boundary}
Content-Disposition: form-data; name="purpose"

`, "utf8")
  let filePart = NSData.dataWithStringEncoding(`
--${boundary}
Content-Disposition: form-data; name="file"; filename="${fileName}"
Content-Type: application/pdf

`, "utf8")
  body.appendData(purposePart)
  body.appendData(purposeData)
  body.appendData(filePart)
  body.appendData(fileData)
  let endBoundary = NSData.dataWithStringEncoding(`--${boundary}--`, "utf8")
  body.appendData(endBoundary)
  request.setHTTPBody(body)
  return request
    } catch (error) {
    showHUD("Error in initFileRequest: "+error)
    return request
  }
}
/**
 * 
 * @param {*} url 
 * @param {*} options 
 * @param {NSData} imageData 
 * @returns 
 */
function initOCRRequest (url,options,imageData) {
  const request = NSMutableURLRequest.requestWithURL(genNSURL(url))
  // try {
  request.setHTTPMethod("Post")
  request.httpShouldHandleCookies = false
  // request.setCachePolicy(4)
  // request.setTimeoutInterval(options.timeout ?? 10)
  let boundary = "------------------------PN7UsJiL7Z78DgpbkjKEWE"//NSUUID.UUID().UUIDString()

  const headers = {
    "User-Agent": "curl/8.4.0",
    "Accept-Encoding":"*",
    "Accept-Language":"*",
    "Connection":"close",
    "Content-Type": "multipart/form-data; boundary="+boundary,
    Accept: "*/*"
  }
  request.setAllHTTPHeaderFields({
    ...headers,
    ...(options.headers ?? {})
  })
  // copyJSON({
  //   ...headers,
  //   ...(options.headers ?? {})
  // })

  
  let body = NSMutableData.new()
  let filePart = NSData.dataWithStringEncoding(`--${boundary}\r\nContent-Disposition: form-data; name="file"; filename="Snipaste_2024-02-18_00-32-59.png"\r\nContent-Type: image/png\r\n\r\n`, 4)
  body.appendData(filePart)
  body.appendData(imageData)
  
  let endBoundary = NSData.dataWithStringEncoding(`\r\n--${boundary}--\r\n`, 4)
  body.appendData(endBoundary)
  // copy(body.base64Encoding())
  request.setHTTPBody(body)
  return request
  //   } catch (error) {
  //   showHUD("Error in initFileRequest: "+error)
  //   return request
  // }
}



function getFileName(fullPath) {
    // 找到最后一个'/'的位置
    let lastSlashIndex = fullPath.lastIndexOf('/');

    // 从最后一个'/'之后截取字符串，得到文件名
    let fileName = fullPath.substring(lastSlashIndex + 1);

    return fileName;
}

function isfileExists(path) {
  return NSFileManager.defaultManager().fileExistsAtPath(path)
}

function getCurrentFile() {
  let docFile = docController().document
  // copy(docFile.pathFile)
  let folder = documentFolder()
  let fullPath = folder+"/"+docFile.pathFile
  if (docFile.pathFile.startsWith("$$$MNDOCLINK$$$")) {
    let fileName = getFileName(docFile.pathFile)
    fullPath = Application.sharedInstance().tempPath + fileName
    // fullPath = docFile.pathFile.replace("$$$MNDOCLINK$$$", "/Users/linlifei/")
  }

  if (!isfileExists(fullPath)) {
    showHUD("Invalid file: "+docFile.pathFile)
    return undefined
  }
  // copy(fullPath)
  let fileName = getFileName(fullPath)
  return{
    name:fileName,
    path:fullPath,
    md5:docFile.docMd5
  }
}
// /Users/linlifei/Library/Containers/QReader.MarginStudy.easy/Data/Documents/iCloud.QReader.MarginStudy.easy/刘福凯；Increased Asian aerosols drive a slowdown of Atlantic Meridional Overturning Circulation；2024.pdf
// /Users/linlifei/Library/Mobile Documents/iCloud~QReader~MarginStudy~easy/Documents/刘福凯；Increased Asian aerosols drive a slowdown of Atlantic Meridional Overturning Circulation；sup.pdf
function getNoteFile(noteId) {
  let note = getNoteById(noteId)
  let docFile = getDocById(note.docMd5)
  if (!docFile) {
    showHUD("No file")
    return undefined
  }
  let folder = documentFolder()
  let fullPath = folder+"/"+docFile.pathFile
  if (docFile.pathFile.startsWith("$$$MNDOCLINK$$$")) {
    let fileName = getFileName(docFile.pathFile)
    fullPath = Application.sharedInstance().tempPath + fileName
    // fullPath = docFile.pathFile.replace("$$$MNDOCLINK$$$", "/Users/linlifei/")
  }
  if (!isfileExists(fullPath)) {
    showHUD("Invalid file: "+docFile.pathFile)
    return undefined
  }
  // copy(fullPath)
  let fileName = getFileName(fullPath)
  return{
    name:fileName,
    path:fullPath,
    md5:docFile.docMd5
  }
}
/**
 * 
 * @param {*} fullPath 
 * @returns {Promise<{object:String,status:String,id:String,purpose:String,bytes:Number,filename:String}>}
 */
async function upload(fullPath,key) {
  let fileData = getFile(fullPath)
  // let fileName = getFileName(fullPath)
  let fileName = `doc_${Date.now()}.pdf`
  const headers = {
    Authorization: "Bearer "+key
  }
  let url = "https://api.moonshot.cn/v1/files"
  // copyJSON(body)
  // showHUD(fileName)
  const request = initFileRequest(url, {
      headers: headers,
      timeout: 60
    },
    "file-extract",
    fileName,
    fileData)
  const queue = NSOperationQueue.mainQueue()

  return new Promise((resolve, reject) => {
    
  NSURLConnection.sendAsynchronousRequestQueueCompletionHandler(
    request,
    queue,
    (res, data, err) => {
      if (err.localizedDescription){
        showHUD(err.localizedDescription)
        reject()
      }
      // if (data.length() === 0) resolve({})
      const result = NSJSONSerialization.JSONObjectWithDataOptions(
        data,
        1<<0
      )
      if (NSJSONSerialization.isValidJSONObject(result)){
        // showHUD(result)
        // copyJSON(result)
        resolve(result)
      }
      resolve(result)
      // showHUD(result)
    }
  )
  })
}

/**
 * 
 * @returns {Promise<Object>}
 */
async function ocrImage(imageData,key) {
  // let fileName = getFileName(fullPath)
  const headers = {
    token: "J4kjn51PoZQyBNAV1fnFzorvxm9HzJI3zYMYZK1EsGXrKCTcgB3wtMowFDPUnIKk"
  }
  let url = "https://server.simpletex.cn/api/latex_ocr"
  // let url = "http://localhost:8000"
  // copyJSON(body)
  // showHUD(fileName)
  const request = initOCRRequest(url, {
      headers: headers
    },
    imageData)
  const queue = NSOperationQueue.mainQueue()
  

  return new Promise((resolve, reject) => {
  NSURLConnection.sendAsynchronousRequestQueueCompletionHandler(
    request,
    queue,
    (res, data, err) => {
      if (err.localizedDescription){
        showHUD(err.localizedDescription)
        reject()
      }
      if (res.statusCode() === 200) {
        showHUD("OCR success")
      }else{
        showHUD("Error in OCR")
      }
      // showHUD(res.statusCode())
      // if (data.length() === 0) resolve({})
      const result = NSJSONSerialization.JSONObjectWithDataOptions(
        data,
        1<<0
      )
      if (NSJSONSerialization.isValidJSONObject(result)){
        // showHUD(result)
        // copyJSON(result)
        resolve(result)
      }
      resolve(result)
      // showHUD(result)
    }
  )
  })
}