JSB.require('utils');
JSB.require('CryptoJS')
JSB.require('network')
// JSB.require('base64')
/** @return {chatglmController} */
const getChatglmController = ()=>self
var chatglmController = JSB.defineClass('chatglmController : UIViewController', {
  viewDidLoad: function() {
    let self = getChatglmController()
    self.init()
    self.view.frame = {x:50,y:50,width:(self.appInstance.osType !== 1) ? 419 : 365,height:450}
    self.lastFrame = self.view.frame;
    self.currentFrame = self.view.frame
    self.title = "main"
    self.moveDate = Date.now()
    self.color = [true,true,true,true,true,true,true,true,true,true,true,true,true,true,true,true]
    self.view.layer.shadowOffset = {width: 0, height: 0};
    self.view.layer.shadowRadius = 15;
    self.view.layer.shadowOpacity = 0.5;
    self.view.layer.shadowColor = UIColor.colorWithWhiteAlpha(0.5, 1);
    self.view.layer.cornerRadius = 11
    self.view.layer.opacity = 1.0
    self.view.layer.borderColor = hexColorAlpha("#9bb2d6",0.8)
    self.view.layer.borderWidth = 0
    self.autoAction = self.config.autoAction
    self.onSelection = self.config.onSelection
    self.onNote = self.config.onNote
    self.onNewExcerpt = self.config.onNewExcerpt
    self.notifyLoc = self.config.notifyLoc
    //通过id获取文件内容
    self.fileContent = {}
    //通过文档md5获取文件id
    self.fileId = getLocalDataByKeyDefault("MNChatglm_fileId", {})
    self.highlightColor = UIColor.blendedColor( hexColorAlpha("#2c4d81",0.8),
      self.appInstance.defaultTextColor,
      0.8
    );
    if (!self.config.delay) {
      self.config.delay = 0
    }
    if (!self.config.colorConfig) {
      self.config.colorConfig = [1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1]
    }
    if (self.config.ignoreShortText == undefined) {
      self.config.ignoreShortText = false
    }
    self.responseView = UIView.new()
    self.responseView.backgroundColor = hexColorAlpha("#f3f3f3")
    self.responseView.layer.cornerRadius = 13
    self.responseView.hidden = true
    self.view.addSubview(self.responseView)

    self.textviewResponse = UITextView.new()
    self.textviewResponse.font = UIFont.systemFontOfSize(16);
    self.textviewResponse.layer.cornerRadius = 8
    self.textviewResponse.backgroundColor = hexColorAlpha("#ffffff",0.8)
    self.textviewResponse.textColor = UIColor.blackColor()
    self.responseView.addSubview(self.textviewResponse)
    self.textviewResponse.text = `Loading...`
    self.textviewResponse.bounces = true

    self.textviewAsk = UITextView.new()
    self.textviewAsk.font = UIFont.systemFontOfSize(16);
    self.textviewAsk.layer.cornerRadius = 8
    self.textviewAsk.backgroundColor = hexColorAlpha("#a9ea7a",0.8)
    self.textviewAsk.textColor = UIColor.blackColor()
    self.responseView.addSubview(self.textviewAsk)
    self.textviewAsk.text = `Input here`
    self.textviewAsk.bounces = true


    if (!self.settingView) {
      self.createSettingView()
    }else{
    }
    self.settingViewLayout()
    
    try {
      self.setButtonText(self.config.promptNames,self.config.currentPrompt)
      self.setTextview(self.config.currentPrompt)
      self.settingView.hidden = false
    } catch (error) {
      showHUD("Error in viewDidLoad: "+error)
      
    }

    self.createButton("closeButton","closeButtonTapped:")
    self.closeButton.setTitleForState('✖️', 0);
    self.closeButton.titleLabel.font = UIFont.systemFontOfSize(10);

    self.createButton("maxButton","maxButtonTapped:")
    self.maxButton.setTitleForState('➕', 0);
    self.maxButton.titleLabel.font = UIFont.systemFontOfSize(10);

    self.createButton("moveButton")


    self.moveGesture = new UIPanGestureRecognizer(self,"onMoveGesture:")
    self.moveButton.addGestureRecognizer(self.moveGesture)
    self.moveGesture.view.hidden = false
    self.moveGesture.addTargetAction(self,"onMoveGesture:")

    self.resizeGesture = new UIPanGestureRecognizer(self,"onResizeGesture:")
    self.saveButton.addGestureRecognizer(self.resizeGesture)
    self.resizeGesture.view.hidden = false
    self.resizeGesture.addTargetAction(self,"onResizeGesture:")
    // self.settingController.view.hidden = false

  },
  viewWillAppear: function(animated) {
  },
  viewWillDisappear: function(animated) {
  },
  viewWillLayoutSubviews: function() {
    let buttonHeight = 25
    // self.view.frame = self.currentFrame
    var viewFrame = self.view.bounds;
    var width    = viewFrame.width
    var height   = viewFrame.height
    self.closeButton.frame = genFrame(width-18,0,18,18)
    self.maxButton.frame = genFrame(width-43,0,18,18)
    self.moveButton.frame = {  x: width*0.5-75,  y: 0,  width: 150,  height: 15,};
    self.responseView.frame = {x:1,y:6,width:width-2,height:height-36}
    height = height-36
    self.textviewAsk.frame = {x:100,y:10,width:width-110,height:height*0.5-20}
    self.textviewResponse.frame = {x:10,y:height*0.5,width:width-110,height:height*0.5-10}
    self.settingViewLayout()
    self.refreshLayout()

  },
  changeSearchOrder: function(sender) {
    // if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
    var commandTable = [
      {title:'Title → Excerpt → Comment',object:self,selector:'setSearchOrder:',param:[1,2,3],checked:self.config.searchOrder ==[1,2,3]},
      {title:'Title → Comment → Excerpt',object:self,selector:'setSearchOrder:',param:[1,3,2],checked:self.config.searchOrder==[1,3,2]},
      {title:'Excerpt → Title → Comment',object:self,selector:'setSearchOrder:',param:[2,1,3],checked:self.config.searchOrder==[2,1,3]},
      {title:'Excerpt → Comment → Title',object:self,selector:'setSearchOrder:',param:[2,3,1],checked:self.config.searchOrder==[2,3,1]},
      {title:'Comment → Title → Excerpt',object:self,selector:'setSearchOrder:',param:[3,1,2],checked:self.config.searchOrder==[3,1,2]},
      {title:'Comment → Excerpt → Title',object:self,selector:'setSearchOrder:',param:[3,2,1],checked:self.config.searchOrder==[3,2,1]},
    ];
    self.view.popoverController = getPopoverAndPresent(sender,commandTable,250)
  },
  setSearchOrder:function (order) {
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
    self.config.searchOrder = order
    self.orderButton.setTitleForState(getOrderText(self.config.searchOrder),0)
    setLocalDataByKey(self.config,"MNChatglm_config")
  },
  changeSource: function(sender) {
    // if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
    var commandTable = [
      {title:'ChatGLM',object:self,selector:'setSource:',param:'ChatGLM',checked:self.config.source =='ChatGLM'},
      {title:'ChatGPT',object:self,selector:'setSource:',param:'ChatGPT',checked:self.config.source =='ChatGPT'},
      {title:'KimiChat',object:self,selector:'setSource:',param:'KimiChat',checked:self.config.source =='KimiChat'},
      {title:'Built-in',object:self,selector:'setSource:',param:'Built-in',checked:self.config.source =='Built-in'}
    ];
    self.view.popoverController = getPopoverAndPresent(sender,commandTable,150)
  },
  setSource: function(param) {

  try {
    let viewFrame = self.view.bounds
    let width = viewFrame.width

    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
    self.config.source = param
    self.sourceButton.setTitleForState("Source: "+self.config.source,0)
    let URL
    let model = [];
    switch (self.config.source) {
      case "ChatGLM":
        modelNames = ["GLM-3-Turbo","GLM-4"]
        self.modelButton.setTitleForState("Model: "+modelNames[self.config.chatglmModel],0)
        break;
      case "ChatGPT":
        modelNames = getModelNames("ChatGPT")
        self.modelButton.setTitleForState("Model: "+modelNames[self.config.model],0) 
        break;
      case "KimiChat":
        modelNames = getModelNames("KimiChat")
        self.modelButton.setTitleForState("Model: "+modelNames[self.config.moonshotModel],0) 
        break;
      default:
        break;
    }
    switch (self.config.source) {
      case "ChatGLM":
        self.URLInput.hidden = true
        self.URLButton.hidden = true
        self.apiKeyInput.hidden = false
        self.apiKeyInput.text = self.config.apikey
        self.apiKeyButton.hidden = false
        self.modelButton.hidden = false
        self.customUsage.hidden = true
        self.usageButton.hidden = true
        self.refreshButton.hidden = true
        self.tunnelButton.hidden = true
        self.modelButton.frame = genFrame(10,290,width-20,40)
        break;
      case "KimiChat":
        self.URLInput.hidden = true
        self.URLButton.hidden = true
        self.apiKeyInput.hidden = false
        self.apiKeyInput.text = self.config.moonshotKey
        self.apiKeyButton.hidden = false
        self.modelButton.hidden = false
        self.customUsage.hidden = true
        self.usageButton.hidden = true
        self.refreshButton.hidden = true
        self.tunnelButton.hidden = true
        self.modelButton.frame = genFrame(10,290,width-20,40)
        break;
      case "ChatGPT":
        self.URLInput.hidden = false
        self.URLButton.hidden = false
        self.apiKeyInput.hidden = false
        self.apiKeyInput.text = self.config.openaiKey
        self.modelButton.hidden = false
        self.customUsage.hidden = false
        self.usageButton.hidden = true
        self.apiKeyButton.hidden = false
        self.refreshButton.hidden = true
        self.tunnelButton.hidden = true
        self.modelButton.frame = genFrame(10,335,width-20,40)
        URL = self.config.url
        if (URL === "") {
          URL = `https://api.openai.com`
        }
        self.URLInput.text = URL
        break;
      case "Built-in":
        self.URLInput.hidden = true
        self.URLButton.hidden = true
        self.apiKeyInput.hidden = true
        self.apiKeyInput.text = ""
        self.modelButton.hidden = true
        self.customUsage.hidden = true
        self.usageButton.hidden = false
        self.apiKeyButton.hidden = true
        self.refreshButton.hidden = false
        self.tunnelButton.hidden = false
        let usage  = getUsage()
        self.usageButton.setTitleForState("Usage: "+usage.usage+"/100",0)
        break;
      default:
        break;
    }
    setLocalDataByKey(self.config,"MNChatglm_config")
  } catch (error) {
    showHUD(error)
  }
  },
  changeModel: function(sender) {
    let self = getChatglmController()
    var commandTable
    switch (self.config.source) {
      case "ChatGLM":
        commandTable = [
          {title:"GLM-3-Turbo",object:self,selector:'setModel:',param:0,checked:self.config.chatglmModel ==0},
          {title:"GLM-4",object:self,selector:'setModel:',param:1,checked:self.config.chatglmModel ==1},
          {title:"GLM-4v",object:self,selector:'setModel:',param:2,checked:self.config.chatglmModel ==2},
        ];
        break;
      case "ChatGPT":
        let modelNames = getModelNames("ChatGPT")
        commandTable = modelNames.map((model,index)=>{
          return {
            title:model,object:self,selector:'setModel:',param:index,checked:self.config.model == index
          }
        })
        break
      case "KimiChat":
        commandTable = [
          {title:"moonshot-v1-8k",object:self,selector:'setModel:',param:0,checked:self.config.moonshotModel ==0},
          {title:"moonshot-v1-32k",object:self,selector:'setModel:',param:1,checked:self.config.moonshotModel ==0},
          {title:"moonshot-v1-128k",object:self,selector:'setModel:',param:2,checked:self.config.moonshotModel ==0}
        ];
        break;
      default:
        break;
    }
    self.view.popoverController = getPopoverAndPresent(sender,commandTable,250)
  },
  setModel: function (params) {
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
    let modelNames = []
    switch (self.config.source) {
      case "ChatGLM":
        modelNames = ["GLM-3-Turbo","GLM-4"]
        self.modelButton.setTitleForState("Model: "+modelNames[params],0)
        self.config.chatglmModel = params
        break;
      case "KimiChat":
        modelNames = getModelNames("KimiChat")
        self.modelButton.setTitleForState("Model: "+modelNames[params],0)
        self.config.moonshotModel = params
        break;
      case "ChatGPT":
        modelNames = getModelNames("ChatGPT")
        self.modelButton.setTitleForState("Model: "+modelNames[params],0)
        self.config.model = params
        break;
      default:
        break;
    }
    setLocalDataByKey(self.config,"MNChatglm_config")
  },
  changeFunc: function (button) {
    let self = getChatglmController()
    try {
      let currentFunc 
      let selector
      if ( button.func) {
        currentFunc = self.config.dynamicFunc ? self.config.dynamicFunc : []
        selector = 'setDynamicFunc:'
      }else{
        currentFunc = self.prompts[self.config.currentPrompt].func ? self.prompts[self.config.currentPrompt].func : []
        selector = 'setFunc:'
      }
      // self.setButtonText(self.config.promptNames,self.config.currentPrompt)
      // setLocalDataByKey(self.prompts,"MNChatglm_prompts")
    var commandTable = [
          {title:"Set Title",object:self,selector:selector,param:0,checked:currentFunc.includes(0)},
          {title:"Add Comment",object:self,selector:selector,param:1,checked:currentFunc.includes(1)},
          {title:"Add Tag",object:self,selector:selector,param:6,checked:currentFunc.includes(6)},
          {title:"Copy MD Link",object:self,selector:selector,param:2,checked:currentFunc.includes(2)},
          {title:"Copy Card URL",object:self,selector:selector,param:3,checked:currentFunc.includes(3)},
          {title:"Copy Text",object:self,selector:selector,param:4,checked:currentFunc.includes(4)},
          {title:"Close",object:self,selector:selector,param:5,checked:currentFunc.includes(5)},
          {title:"None",object:self,selector:selector,param:-1,checked:currentFunc.length === 0},
          {title:"All",object:self,selector:selector,param:100,checked:currentFunc.length === 7},
        ];
    self.view.popoverController = getPopoverAndPresent(button,commandTable,250)
    } catch (error) {
      showHUD(error)
    }
  },
  setFunc(param) {
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
try {
    let currentFunc = self.prompts[self.config.currentPrompt].func ? self.prompts[self.config.currentPrompt].func : []

    switch (param) {
      case -1:
        currentFunc = []
        break;
      case 100:
        currentFunc = [0,1,2,3,4,5,6]
        break
      default:
        if (currentFunc.includes(param)) {
          currentFunc = currentFunc.filter(func=> func!==param)
        }else{
          currentFunc.push(param)
        }
        currentFunc.sort(function(a, b) {
          return a - b;
        });
        break;
    }
    self.prompts[self.config.currentPrompt].func = currentFunc
    setLocalDataByKey(self.prompts,"MNChatglm_prompts")
    // copyJSON(self.prompts[self.config.currentPrompt])
} catch (error) {
  showHUD(error)
}
  },
  setDynamicFunc(param) {
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
try {
    let currentFunc = self.config.dynamicFunc ? self.config.dynamicFunc : []
    switch (param) {
      case -1:
        currentFunc = []
        break;
      case 100:
        currentFunc = [0,1,2,3,4,5,6]
        break
      default:
        if (currentFunc.includes(param)) {
          currentFunc = currentFunc.filter(func=> func!==param)
        }else{
          currentFunc.push(param)
        }
        currentFunc.sort(function(a, b) {
          return a - b;
        });
        break;
    }
    self.config.dynamicFunc = currentFunc
    setLocalDataByKey(self.config,"MNChatglm_config")
    // copyJSON(self.prompts[self.config.currentPrompt])
} catch (error) {
  showHUD(error)
}
  },
  changeOpacityTo:function (opacity) {
    self.view.layer.opacity = opacity
  },
  openSettingView:function () {
    let self = getChatglmController()
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
    // self.settingController.view.hidden = false
    if (!self.settingView) {
      self.createSettingView()
    }else{
    }
    self.settingViewLayout()
    
    try {
      self.setButtonText(self.config.promptNames,self.config.currentPrompt)
      self.setTextview(self.config.currentPrompt)
      self.settingView.hidden = false
    } catch (error) {
      showHUD(error)
      
    }

    // self.view.addSubview(self.tabView)
  },
  askWithPrompt: async function () {
    let self = getChatglmController()
    let currentFunc = self.prompts[self.config.currentPrompt].func ? self.prompts[self.config.currentPrompt].func : []
    let config = {title:self.titleInput.text,context:self.contextInput.text,system:self.systemInput.text,func:currentFunc}
    self.prompts[self.config.currentPrompt] = config
    self.setButtonText(self.config.promptNames,self.config.currentPrompt)
    setLocalDataByKey(self.prompts,"MNChatglm_prompts")
  try {
    self.notifyController.noteid = self.currentNoteId
    self.notifyController.text = self.selectedText
    self.ask()
  } catch (error) {
    showHUD(error)
  }
  },
  resetConfig: function (engine) {
    let self = getChatglmController()
    let defaultPrompts = {
        Translate:                      {title: "翻译",context:"请翻译下面这段话：{{context}}"},
        Keyword:                        {title: "关键词",context:"请为下面这段话提取关键词：{{context}}"},
        Title:                          {title: "标题",context:"请为下面这段话生成标题：{{context}}"}
    }
    self.prompts = defaultPrompts
    self.config.promptNames = Object.keys(self.prompts)
    self.config.currentPrompt = self.config.promptNames[0]
    self.setButtonText(self.config.promptNames,self.config.currentPrompt)
    self.setTextview(self.config.currentPrompt)
    setLocalDataByKey(self.config,'MNChatglm_config')
    setLocalDataByKey(self.prompts,"MNChatglm_prompts")
    removeLocalDataByKey("MNChatglm_dynamicPrompt")
  },

  toggleWindowLocation: function () {
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
    switch (self.config.notifyLoc) {
      case 1:
        self.config.notifyLoc = 0
        self.windowLocationButton.setTitleForState("Notification: Left",0)
        self.notifyController.locationButton.setTitleForState("Left",0)
        break;
      case 0:
        self.config.notifyLoc = 1
        self.windowLocationButton.setTitleForState("Notification: Right",0)
        self.notifyController.locationButton.setTitleForState("Right",0)
        break;
      default:
        break;
    }
    // self.notifyController.config = self.config
    setLocalDataByKey(self.config,'MNChatglm_config')
  },
  closeButtonTapped: function() {
    // self.view.hidden = true;
    // self.custom = false;
    // self.dynamic = true;
    if (self.addonBar) {
      self.hide(self.addonBar.frame)
    }else{
      self.hide()
    }
    self.searchedText = ""
  },
  maxButtonTapped: function() {
    if (self.customMode === "full") {
      self.customMode = "none"
      self.custom = false;
      self.hideAllButton()
      UIView.animateWithDurationAnimationsCompletion(0.3,()=>{
        self.view.frame = self.lastFrame
        self.currentFrame = self.lastFrame
      },
      ()=>{
        self.showAllButton()
      
      })
      return
    }
    const frame = Application.sharedInstance().studyController(self.view.window).view.bounds
    self.lastFrame = self.view.frame
    self.customMode = "full"
    self.custom = true;
    self.dynamic = false;
    self.hideAllButton()


    UIView.animateWithDurationAnimationsCompletion(0.3,()=>{
      self.view.frame = {x:40,y:50,width:frame.width-80,height:frame.height-70}
      self.currentFrame = {x:40,y:50,width:frame.width-80,height:frame.height-70}
    },
    ()=>{
      self.showAllButton()
    })
  },
  onMoveGesture:function (gesture) {
    self.dynamic = false;
    let locationToMN = gesture.locationInView(self.appInstance.studyController(self.view.window).view)
    if (!self.locationToButton || !self.miniMode && (Date.now() - self.moveDate) > 100) {
      let translation = gesture.translationInView(self.appInstance.studyController(self.view.window).view)
      let locationToBrowser = gesture.locationInView(self.view)
      let locationToButton = gesture.locationInView(gesture.view)
      let buttonFrame = self.moveButton.frame
      let newY = locationToButton.y-translation.y 
      let newX = locationToButton.x-translation.x
      if (gesture.state !== 3 && (newY<buttonFrame.height+5 && newY>-5 && newX<buttonFrame.width+5 && newX>-5 && Math.abs(translation.y)<20 && Math.abs(translation.x)<20)) {
        self.locationToBrowser = {x:locationToBrowser.x-translation.x,y:locationToBrowser.y-translation.y}
        self.locationToButton = {x:newX,y:newY}
      }
      // if ((newY<buttonFrame.height && newY>0 && newX<buttonFrame.width && newX>0 && Math.abs(translation.y)<20 && Math.abs(translation.x)<20) || !self.locationToBrowser) {

      // }
    }
    self.moveDate = Date.now()
    // let location = {x:locationToMN.x - self.locationToBrowser.x,y:locationToMN.y -self.locationToBrowser.y}
    let location = {x:locationToMN.x - self.locationToButton.x-gesture.view.frame.x,y:locationToMN.y -self.locationToButton.y-gesture.view.frame.y}

    let frame = self.view.frame
    var viewFrame = self.view.bounds;
    let studyFrame = self.appInstance.studyController(self.view.window).view.bounds
    let y = location.y
    if (y<=0) {
      y = 0
    }
    if (y>=studyFrame.height-15) {
      y = studyFrame.height-15
    }
    let x = location.x
    
    if (self.custom) {
      self.customMode = "None"
      UIView.animateWithDurationAnimations(0.2,()=>{
        self.view.frame = genFrame(x,y,self.lastFrame.width,self.lastFrame.height)
        self.currentFrame  = self.view.frame
      })
    }else{
      self.view.frame = genFrame(x,y,frame.width,frame.height)
      self.currentFrame  = self.view.frame
    }
    self.custom = false;
  },
  onResizeGesture:function (gesture) {
    self.custom = false;
    self.customMode = "none"
    let baseframe = gesture.view.frame
    let locationToBrowser = gesture.locationInView(self.view)
    let frame = self.view.frame
    let width = locationToBrowser.x+baseframe.width*0.5
    let height = locationToBrowser.y+baseframe.height*0.5
    if (width <= 375) {
      width = 375
    }
    if (height <= 475) {
      height = 475
    }
    //  self.view.frame = {x:frame.x,y:frame.y,width:frame.width+translationX,height:frame.height+translationY}
    self.view.frame = {x:frame.x,y:frame.y,width:width,height:height}
    self.currentFrame  = self.view.frame
  },
  knowledgeButtonTapped: function (params) {
    self.configView.hidden = true
    self.donationView.hidden = true
    self.advanceView.hidden = true
    self.autoActionView.hidden = true
    self.knowledgeView.hidden = false
    self.configButton.backgroundColor = hexColorAlpha("#9bb2d6",0.8)
    self.advancedButton.backgroundColor = hexColorAlpha("#9bb2d6",0.8)
    self.knowledgeButton.backgroundColor = hexColorAlpha("#457bd3",0.8)
    self.actionButton.backgroundColor = hexColorAlpha("#9bb2d6",0.8)


  },
  actionButtonTapped: function (params) {
    self.configView.hidden = true
    self.donationView.hidden = true
    self.advanceView.hidden = true
    self.autoActionView.hidden = false
    self.knowledgeView.hidden = true
    self.configButton.backgroundColor = hexColorAlpha("#9bb2d6",0.8)
    self.advancedButton.backgroundColor = hexColorAlpha("#9bb2d6",0.8)
    self.knowledgeButton.backgroundColor = hexColorAlpha("#9bb2d6",0.8)
    self.actionButton.backgroundColor = hexColorAlpha("#457bd3",0.8)


  },
  advancedButtonTapped: function (params) {
    self.configView.hidden = true
    self.donationView.hidden = true
    self.advanceView.hidden = false
    self.knowledgeView.hidden = true
    self.autoActionView.hidden = true

    self.configButton.backgroundColor = hexColorAlpha("#9bb2d6",0.8)
    self.advancedButton.backgroundColor = hexColorAlpha("#457bd3",0.8)
    self.knowledgeButton.backgroundColor = hexColorAlpha("#9bb2d6",0.8)
    self.actionButton.backgroundColor = hexColorAlpha("#9bb2d6",0.8)
    if (self.config.source === "Built-in") {
      let usage  = getUsage()
      self.usageButton.setTitleForState("Usage: "+usage.usage+"/100",0)
    }
  },
  configButtonTapped: function (params) {
    self.configView.hidden = false
    self.advanceView.hidden = true
    self.knowledgeView.hidden = true
    self.autoActionView.hidden = true
    self.donationView.hidden = true
    self.configButton.backgroundColor = hexColorAlpha("#457bd3",0.8)
    self.advancedButton.backgroundColor = hexColorAlpha("#9bb2d6",0.8)
    self.actionButton.backgroundColor = hexColorAlpha("#9bb2d6",0.8)
    self.knowledgeButton.backgroundColor = hexColorAlpha("#9bb2d6",0.8)

  },
  configSystemTapped: function (params) {
    self.SystemButton.backgroundColor = hexColorAlpha("#457bd3",0.8)
    self.contextButton.backgroundColor = hexColorAlpha("#9bb2d6",0.8)
    self.contextInput.hidden = true
    self.systemInput.hidden = false
  },
  configContextTapped: function (params) {
    self.SystemButton.backgroundColor = hexColorAlpha("#9bb2d6",0.8)
    self.contextButton.backgroundColor = hexColorAlpha("#457bd3",0.8)
    self.contextInput.hidden = false
    self.systemInput.hidden = true
  },
  configSaveTapped: function (params) {
    let self = getChatglmController()
    try {
      let func = self.prompts[self.config.currentPrompt].func
      let title = self.titleInput.text ? self.titleInput.text : ""
      let context = self.contextInput.text ? self.contextInput.text : ""
      let system = self.systemInput.text ? self.systemInput.text : ""

      let config = {title:title,context:context,system:system,func:func ? func : []}
      self.prompts[self.config.currentPrompt] = config
      self.setButtonText(self.config.promptNames,self.config.currentPrompt)
      setLocalDataByKey(self.prompts,"MNChatglm_prompts")
      showHUD("Save prompt: "+self.prompts[self.config.currentPrompt].title)
    } catch (error) {
      showHUD(error, self.view.window, 2);
    }
    // self.appInstance.studyController(self.view.window).focusNoteInMindMapById("FA871E6D-A175-4D1E-8568-63510CA82E42")
  },
  saveKnowledgeButtonTapped: function (params) {
    try {
      self.knowledge = self.knowledgeInput.text
      setLocalDataByKey(self.knowledge,"MNChatglm_knowledge")
      showHUD("Save knowledge")
    } catch (error) {
      showHUD(error);
    }
    // self.appInstance.studyController(self.view.window).focusNoteInMindMapById("FA871E6D-A175-4D1E-8568-63510CA82E42")
  },
  changeTunnel: function(sender) {
    var commandTable = [
      {title:'Tunnel 1️⃣',object:self,selector:'setTunnel:',param:0,checked:self.config.tunnel ==0},
      {title:'Tunnel 2️⃣',object:self,selector:'setTunnel:',param:1,checked:self.config.tunnel ==1},
      {title:'Tunnel 3️⃣',object:self,selector:'setTunnel:',param:2,checked:self.config.tunnel ==2},
      {title:'Tunnel 4️⃣',object:self,selector:'setTunnel:',param:3,checked:self.config.tunnel ==3},
    ];
    self.view.popoverController = getPopoverAndPresent(sender,commandTable,150)
  },
  setTunnel: function name(param) {
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
    let tunnels = ["Tunnel: 1️⃣","Tunnel: 2️⃣","Tunnel: 3️⃣","Tunnel: 4️⃣"]
    self.config.tunnel = param
    self.tunnelButton.setTitleForState(tunnels[param],0)
    setLocalDataByKey(self.config,'MNChatglm_config')
  },
  refreshKey: async function (params) {
    // let self = getChatglmController()
    // let image = docController().imageFromSelection()
    // showHUD("message"+imageData)
    // let image = UIImage.imageWithData(imageData).pngData()
    // let image = NSData.dataWithContentsOfFile(Application.sharedInstance().tempPath+"/Snipaste_2024-02-18_00-32-59.png")
    // let imageData = getImage(Application.sharedInstance().tempPath+"/Snipaste_2024-02-18_00-32-59.png")
    // let temp = UIImage.imageWithData(imageData).pngData()
    // showHUD(Application.sharedInstance().tempPath+"test.png")
    // copy(Application.sharedInstance().tempPath+"test.png")
    // let key = "J4kjn51PoZQyBNAV1fnFzorvxm9HzJI3zYMYZK1EsGXrKCTcgB3wtMowFDPUnIKk"
    // let url = "https://server.simpletex.cn/api/latex_ocr"
    // let res = await ocrImage(image, key)
    // let res = await self.baiduFormulaOCR(imageData.base64Encoding())
    // let option = xunfeiOption(image)
    // // // copyJSON(option)
    // let res = await self.fetch(option.url,{
    //   method:"POST",
    //   headers: option.headers,
    //   json:option.body
    // })
    // try {
      

    // copy(res.res.latex)
    // let target = '';
    // for (let i of res.data['region']) {
    //   if (i.type === "text") {
    //     target += i['recog']['content'] + '\n';
    //   }
    // }
    // target = target.replaceAll(' ifly-latex-begin ', '');
    // target = target.replaceAll(' ifly-latex-end ', '');
    // copy(target.trim())
    //     } catch (error) {
    //   showHUD(error)
    // }
    // return target.trim();
    // let text = res.data.region.map(r=>{
    //   if (r.type === "text") {
    //     return r.recog.content
    //   }
    //   return ""
    // }).join("")
    // copy(text)

    let self = getChatglmController()
    showHUD("Refreshing...")
    let keys = await self.fetchKeys()
    if (keys) {
      self.keys = keys 
      setLocalDataByKey(self.keys,'MNChatglm_builtInKeys')
      if (keys.message) {
        showHUD(keys.message)
      }else{
        showHUD("error")
      }
      self.refreshButton.setTitleForState(`Refresh (1️⃣: ${keys.key0.keys.length}, 2️⃣: ${keys.key1.keys.length}, 3️⃣: ${keys.key2.keys.length}, 4️⃣: ${keys.key3.keys.length})`,0)
    }else{
      showHUD("error")
    }
  },
  refreshUsage: async function (button) {
    if (button.builtIn) {
      let usage  = getUsage()
      self.usageButton.setTitleForState("Usage: "+usage.usage+"/100",0)
    }else{
      let self = getChatglmController()
      showHUD("Fetching usage")
      let usage  = await self.getUsage()
      self.customUsage.setTitleForState(`Usage: ${usage.usage/100.}, Total: ${usage.total}`,0) 
    }
    // copy(fy(usage))
  },
  configAddTapped: function (params) {
    let self = getChatglmController()
    self.titleInput.text = "New prompt"
    self.contextInput.text = "input your prompt"
    self.systemInput.text = ""
    let i = 0
    while (self.prompts["customEngine"+i]) {
      i = i+1
    }
    let prompts = self.prompts
    let config = {title:self.titleInput.text,context:self.contextInput.text}
    prompts["customEngine"+i] = config
    self.prompts = prompts
    self.config.promptNames = self.config.promptNames.concat(("customEngine"+i))
    self.setButtonText(self.config.promptNames,"customEngine"+i)
    self.config.currentPrompt = "customEngine"+i
    self.refreshLayout()
    setLocalDataByKey(self.config,'MNChatglm_config')
    setLocalDataByKey(self.prompts,"MNChatglm_prompts")
  },
  addVariable: function (sender) {
    let vars = ['{{card}}','{{context}}','{{textOCR}}','{{knowledge}}','{{noteDocInfo}}','{{currentDocInfo}}']
    var commandTable = vars.map(variable=>{
      return {title:variable,object:self,selector:'insert:',param:variable}
    })
    self.view.popoverController = getPopoverAndPresent(sender,commandTable,150)
    // let self = getChatglmController()
    // let range = self.contextInput.selectedRange
    // let pre = self.contextInput.text.slice(0,range.location)
    // let post = self.contextInput.text.slice(range.location)
    // self.contextInput.text = pre+"{{context}}"+post
    // copyJSON(range)
  },
  insert: function (variable) {
    let self = getChatglmController()
    if (!self.contextInput.hidden) {
      let range = self.contextInput.selectedRange
      let pre = self.contextInput.text.slice(0,range.location)
      let post = self.contextInput.text.slice(range.location+range.length)
      self.contextInput.text = pre+variable+post
    }
    if (!self.systemInput.hidden) {
      let range = self.systemInput.selectedRange
      let pre = self.systemInput.text.slice(0,range.location)
      let post = self.systemInput.text.slice(range.location+range.length)
      self.systemInput.text = pre+variable+post
    }
  },
  configDeleteTapped: function (params) {
      

    delete self.prompts[self.config.currentPrompt]
    self.config.promptNames = self.config.promptNames.filter(item=>item !== self.config.currentPrompt)
    self.config.currentPrompt = self.config.promptNames[0]
    self.setButtonText(self.config.promptNames,self.config.currentPrompt)
    self.refreshLayout()
    setLocalDataByKey(self.config,"MNChatglm_config")
    NSUserDefaults.standardUserDefaults().setObjectForKey(self.prompts,"MNChatglm_prompts")
  },
  pasteApiKey:function (params) {
    let apikey = UIPasteboard.generalPasteboard().string.trim()
    self.apiKeyInput.text = apikey
    switch (self.config.source) {
      case "ChatGLM":
        self.config.apikey = apikey
        break;
      case "ChatGPT":
        self.config.openaiKey = apikey
        break;
      case "KimiChat":
        self.config.moonshotKey = apikey
        break;
      default:
        break;
    }
    setLocalDataByKey(self.config,'MNChatglm_config')
  },
  pasteURL:function (params) {
    let URL = UIPasteboard.generalPasteboard().string.trim()
    self.URLInput.text = URL
    self.config.url = URL
    setLocalDataByKey(self.config,'MNChatglm_config')
  },
  pasteOCRKey:function (params) {
    let apikey = UIPasteboard.generalPasteboard().string.trim()
    self.OCRKeyInput.text = apikey
    self.config.simpleTexKey = apikey
    setLocalDataByKey(self.config,'MNChatglm_config')
  },
  toggleSelected: async function (button) {
    let self = getChatglmController()
    button.isSelected = !button.isSelected
    let clickDate = Date.now()
    if (button.clickDate && clickDate-button.clickDate<300) {
      let currentFunc = self.prompts[self.config.currentPrompt].func ? self.prompts[self.config.currentPrompt].func : []
      let config = {title:self.titleInput.text,context:self.contextInput.text,system:self.systemInput.text,func:currentFunc}
      self.prompts[self.config.currentPrompt] = config
      self.setButtonText(self.config.promptNames,self.config.currentPrompt)
      setLocalDataByKey(self.prompts,"MNChatglm_prompts")

      self.notifyController.noteid = self.currentNoteId
      self.notifyController.text = self.selectedText
      self.notifyController.currentPrompt = self.config.currentPrompt
      if (self.selectedText === "") {
        showHUD("no text/card selected")
        return
      }
      self.ask(self.selectedText)
      return
    }else{
      button.clickDate = clickDate
    }
    let title = button.id
    self.config.currentPrompt = title
    self.words.forEach((entryName,index)=>{
      if (entryName !== title) {
        self["nameButton"+index].isSelected = false
        self["nameButton"+index].backgroundColor = hexColorAlpha("#9bb2d6",0.8);
      }
    })
    if (button.isSelected) {
      self.setTextview(title)
      button.backgroundColor = hexColorAlpha("#457bd3",0.8)
    }else{

      button.backgroundColor = hexColorAlpha("#9bb2d6",0.8);
    }
    setLocalDataByKey(self.config,'MNChatglm_config')
  },
  toggleAutoAction:function () {
    self.config.autoAction = !self.config.autoAction
    setLocalDataByKey(self.config,'MNChatglm_config')
    if (self.config.autoAction) {
      self.autoActionButton.backgroundColor = hexColorAlpha("#457bd3",0.8)
      self.autoActionButton.setTitleForState("Auto Action: ✅")

    }else{
      self.autoActionButton.backgroundColor = hexColorAlpha("#9bb2d6",0.8)
      self.autoActionButton.setTitleForState("Auto Action: ❌")
    }
    self.onSelectionButton.hidden = !self.config.autoAction
    self.onNewExcerptButton.hidden = !self.config.autoAction
    self.onNoteButton.hidden = !self.config.autoAction
    self.ignoreButton.hidden = !self.config.autoAction
    self.delayButton.hidden = !self.config.autoAction

    for (let index = 0; index < 32; index++) {
      self["ColorButton"+index].hidden = !self.config.autoAction
    }
    self.appInstance.studyController(self.view.window).refreshAddonCommands();
  },
  toggleOnSelection:function () {
    self.config.onSelection = !self.config.onSelection
    setLocalDataByKey(self.config,'MNChatglm_config')
    if (self.config.onSelection) {
      self.onSelectionButton.backgroundColor = hexColorAlpha("#457bd3",0.8)
      self.onSelectionButton.setTitleForState("On Selection: ✅")
    }else{
      self.onSelectionButton.backgroundColor = hexColorAlpha("#9bb2d6",0.8)
      self.onSelectionButton.setTitleForState("On Selection: ❌")
    }
  },
  toggleOnNote:function () {
    self.config.onNote = !self.config.onNote
    setLocalDataByKey(self.config,'MNChatglm_config')

    if (self.config.onNote) {
      self.onNoteButton.backgroundColor = hexColorAlpha("#457bd3",0.8)
      self.onNoteButton.setTitleForState("On Note: ✅")
    }else{
      self.onNoteButton.backgroundColor = hexColorAlpha("#9bb2d6",0.8)
      self.onNoteButton.setTitleForState("On Note: ❌")
    }
  },
  toggleOnNewExcerpt:function () {
    self.config.onNewExcerpt = !self.config.onNewExcerpt
    setLocalDataByKey(self.config,'MNChatglm_config')
    if (self.config.onNewExcerpt) {
      self.onNewExcerptButton.backgroundColor = hexColorAlpha("#457bd3",0.8)
      self.onNewExcerptButton.setTitleForState("On New Excerpt: ✅")
    }else{
      self.onNewExcerptButton.backgroundColor = hexColorAlpha("#9bb2d6",0.8)
      self.onNewExcerptButton.setTitleForState("On New Excerpt: ❌")
    }
  },
  changeDelay: function(sender) {
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
    var commandTable = [
      {title:'2.0s',object:self,selector:'changeDelayTo:',param:2.0},
      {title:'1.5s',object:self,selector:'changeDelayTo:',param:1.5},
      {title:'1.0s',object:self,selector:'changeDelayTo:',param:1.0},
      {title:'0.5s',object:self,selector:'changeDelayTo:',param:0.5}
    ];
    self.view.popoverController = getPopoverAndPresent(sender,commandTable,100)
  },
  changeDelayTo: function(delay) {
    self.config.delay = delay
    self.delayButton.setTitleForState("Delay: "+delay+"s")
    setLocalDataByKey(self.config,'MNChatglm_config')
    showHUD("Set delay to "+delay+"s")
  },
  toggleColorConfig: function (button) {
    if (self.config.colorConfig[button.index]) {
      self.config.colorConfig[button.index] = 0
      button.setTitleForState("✖️",0)
    }else{
      self.config.colorConfig[button.index] = 1
      button.setTitleForState("✓",0)
    }
    setLocalDataByKey(self.config,'MNChatglm_config')
  },
  toggleDynamic: function () {
    if (self.config.dynamic) {
      self.config.dynamic = false
      self.dynamicButton.setTitleForState("Dynamic: ❌",0)
    }else{
      self.config.dynamic = true
      self.dynamicButton.setTitleForState("Dynamic: ✅",0)
    }
    setLocalDataByKey(self.config,'MNChatglm_config')
  },
  toggleIgnoreShortText:function (button) {
    self.config.ignoreShortText = !self.config.ignoreShortText
    button.setTitleForState("Ignore short text: "+(self.config.ignoreShortText?"✅":"🚫"))
    if (self.config.ignoreShortText) {
      self.ignoreButton.backgroundColor = hexColorAlpha("#457bd3",0.8)
    }else{
      self.ignoreButton.backgroundColor = hexColorAlpha("#9bb2d6",0.8)
    }
    setLocalDataByKey(self.config,'MNChatglm_config')
  },
  inputDynamicPrompt:function () {
    let defaultDynamicPrompt = {
      "note":"list below is the structure of a card:\n{{card}}",
      "text":"{{context}}"
    }
    let dynamicPrompt = getLocalDataByKeyDefault("MNChatglm_dynamicPrompt", defaultDynamicPrompt)
    if (self.dynamicNoteInput.hidden) {
      showHUD("Upper: note selected; Lower: text selected")
      self.dynamicNoteInput.hidden = false
      self.advanceView.bringSubviewToFront(self.dynamicNoteInput)
      self.dynamicNoteInput.text = dynamicPrompt.note
      self.dynamicTextInput.hidden = false
      self.advanceView.bringSubviewToFront(self.dynamicTextInput)
      self.dynamicTextInput.text = dynamicPrompt.text
    }else{
      showHUD("Save Dynamic prompt")
      dynamicPrompt.note = self.dynamicNoteInput.text
      dynamicPrompt.text = self.dynamicTextInput.text
      self.dynamicNoteInput.hidden = true
      self.dynamicTextInput.hidden = true
      setLocalDataByKey(dynamicPrompt, "MNChatglm_dynamicPrompt")
    }

  }
});
chatglmController.prototype.init = function () {
  // /**
  //  * @type {chatglmController}
  //  */
  // let ctr = this
  this.homePageURL = 'https://chatglm.cn/detail'
  this.homeImage = getImage(this.mainPath + `/home.png`)
  this.gobackImage = getImage(this.mainPath + `/goback.png`)
  this.goforwardImage = getImage(this.mainPath + `/goforward.png`)
  this.reloadImage = getImage(this.mainPath + `/reload.png`)
  this.stopImage = getImage(this.mainPath + `/stop.png`)
  this.QRCodeImage = getImage(this.mainPath + `/QRCode.png`)
  this.settingImage = getImage(this.mainPath + `/setting.png`)
  this.appInstance = Application.sharedInstance();
  this.custom = false;
  this.customMode = "None"
  this.dynamic = true;
  this.miniMode = false;
  this.shouldCopy = false
  this.shouldComment = false
  this.selectedText = '';
  this.searchedText = '';
}

/**
 * @this {chatglmController}
 */
chatglmController.prototype.getQuestion = async function(prompt = this.config.currentPrompt) {
try {
  //因为dynamicController可能还没有被创建，所以要加个判断
  let OCRMode = this.dynamicController ? this.dynamicController.OCREnhancedMode : false
  let context = this.prompts[prompt].context
  let system = this.prompts[prompt].system
  let contextMessage
  let systemMessage
  let question
  if (this.currentNoteId) {
    contextMessage = await this.getNoteVarInfo(this.currentNoteId,context,OCRMode)
    if (system) {
      systemMessage = await this.getNoteVarInfo(this.currentNoteId,system,OCRMode)
      question = [{role:"system",content:systemMessage},{role: "user", content: contextMessage}]
      return question
    }
    question = [{role: "user", content: contextMessage}]
    return question
  }else{
    contextMessage = await this.getTextVarInfo(context,OCRMode)
    if (system) {
      systemMessage = await this.getTextVarInfo(system,OCRMode)
      question = [{role:"system",content:systemMessage},{role: "user", content: contextMessage}]
      return question
    }
    question = [{role: "user", content: contextMessage}]
    return question
  }
} catch (error) {
  showHUD("Error in getQuestion: "+error)
}
};

/**
 * @this {chatglmController}
 */
chatglmController.prototype.getQuestionOnNote = async function(noteid,prompt = this.config.currentPrompt) {
  try {
  let context = this.prompts[prompt].context
  let system = this.prompts[prompt].system
  let contextMessage
  let systemMessage
  let question
  let OCRMode = this.dynamicController.OCREnhancedMode
  contextMessage = await this.getNoteVarInfo(noteid,context,OCRMode)
  if (system) {
    systemMessage = await this.getNoteVarInfo(noteid,system,OCRMode)
    question = [{role:"system",content:systemMessage},{role: "user", content: contextMessage}]
    return question
  }
  question = [{role: "user", content: contextMessage}]
  // copyJSON(question)
  return question
    } catch (error) {
    showHUD(error)
  }
}

/**
 * @this {chatglmController}
 */
chatglmController.prototype.replacVar = async function(text,varInfo) {
  let vars = Object.keys(varInfo)
  let original = text
  for (let i = 0; i < vars.length; i++) {
    const variable = vars[i];
    const variableText = varInfo[variable]
    original = original.replace(`{{${variable}}}`,variableText)
  }
  // copy(original)
  return original
}
/**
 * @this {chatglmController}
 */
chatglmController.prototype.getNoteVarInfo = async function(noteid,text,OCR_Enabled=false) {
  let config = {}
  let hasContext = text.includes("{{context}}")
  let hasOCR = text.includes("{{textOCR}}")
  let hasCard = text.includes("{{card}}")
  let note = getNoteById(noteid)
  if (OCR_Enabled) {
    if (hasContext || hasOCR) {
      let contextVar = await this.dynamicController.getTextForSearch(note,true)
      if (hasContext) { config.context = contextVar }
      if (hasOCR) { config.textOCR = contextVar }
    }
    if (hasCard) {
      let cardStructure = this.genCardStructure(true)
      let haveImage = false
      if (cardStructure.excerpt && cardStructure.excerpt.image) {
        cardStructure.excerpt = await this.getTextOCR(getMediaByHash(cardStructure.excerpt.image))
        haveImage = true
      }
      if (cardStructure.comments) {
        let comments = cardStructure.comments.map(async comment=>{
          if (comment.image) {
            if (haveImage) { return "" }
            haveImage = true
            return await this.getTextOCR(getMediaByHash(comment.image))
          }
          return comment
        })
        cardStructure.comments = comments
      }
      let cardStructureString = JSON.stringify(cardStructure,null,2)
      config.card = cardStructureString
    }
  }else{
    if (hasContext) {
      contextVar = await this.dynamicController.getTextForSearch(note)
      if (!contextVar) {
        showHUD("No text in note/card!")
        return undefined
      }
      config.context = contextVar
    }
    if (hasCard) {
      let cardStructure = this.genCardStructure()
      // copyJSON(cardStructure)
      if (!Object.keys(cardStructure).length) {
        showHUD("No text in note/card!")
        return undefined
      }
      let cardStructureString = JSON.stringify(cardStructure,null,2)
      config.card = cardStructureString
    }
    if (hasOCR) {
      contextVar = await this.dynamicController.getTextForSearch(note,true)
      config.textOCR = contextVar
    }
  }
  if (text.includes("{{currentDocInfo}}")) {
    let currentFile = getCurrentFile()
    if (!currentFile) {
      return undefined
    }
    config.currentDocInfo = await this.getFileContent(currentFile)
  }
  if (text.includes("{{noteDocInfo}}")) {
    let currentFile = getNoteFile(this.noteId)
    if (!currentFile) {
      currentFile = getCurrentFile()
    }
    if (!currentFile) {
      return undefined
    }
    config.noteDocInfo = await this.getFileContent(currentFile)
    // copy(fileContent)
  }
  let replacedText = this.replacVar(text, config)
  // copyJSON(replacedText)
  return replacedText
}

/**
 * @this {chatglmController}
 */
chatglmController.prototype.getTextVarInfo = async function(text,OCR_Enabled=false) {
  try {
  let config = {}
  let image = undefined
  let fileContent = undefined
  let hasOCR = text.includes("{{textOCR}}")
  let hasContext = text.includes("{{context}}")
  let hasCard = text.includes("{{card}}")
  let hasCurrentDocInfo = text.includes("{{currentDocInfo}}")
  let hasNoteDocInfo = text.includes("{{noteDocInfo}}")

  let selectedText = docController().selectionText
  if (hasOCR || !selectedText || (OCR_Enabled && hasContext)) {
    image = docController().imageFromSelection()
  }
  if (image) {
    selectedText = await this.getTextOCR(image)
    config.textOCR = selectedText
  }
  if (hasContext) {
    config.context = selectedText
  }

  if (hasCard) {
    config.card = selectedText
  }

  if (hasCurrentDocInfo || hasNoteDocInfo) {
    let currentFile = getCurrentFile()
    if (!currentFile) {
      return undefined
    }
    fileContent = await this.getFileContent(currentFile)
    // copy(fileContent)
    if (hasCurrentDocInfo) {
      config.currentDocInfo = fileContent
    }
    if (hasNoteDocInfo) {
      config.noteDocInfo = fileContent
    }
  }
  // copyJSON(config)
  return this.replacVar(text, config)
    } catch (error) {
    showHUD(error)
  }

}

/**
 * @this {chatglmController}
 */
chatglmController.prototype.getQuestionOnText = async function(text,prompt = this.config.currentPrompt) {

  try {
    
  let context = this.prompts[prompt].context
  let system = this.prompts[prompt].system
  let OCRMode = this.dynamicController.OCREnhancedMode
  let contextMessage = await this.getTextVarInfo(context,OCRMode)
  if (system) {
    let systemMessage = await this.getTextVarInfo(system,OCRMode)
    // copy(systemMessage)
    let question = [{role:"system",content:systemMessage},{role: "user", content: contextMessage}]
    return question
  }
  let question = [{role: "user", content: contextMessage}]
  return question
    } catch (error) {
    showHUD(error)
  }

}
chatglmController.prototype.changeButtonOpacity = function(opacity) {
    this.moveButton.layer.opacity = opacity
    this.maxButton.layer.opacity = opacity
    this.closeButton.layer.opacity = opacity
}
chatglmController.prototype.setButtonLayout = function (button,targetAction) {
    button.autoresizingMask = (1 << 0 | 1 << 3);
    button.setTitleColorForState(UIColor.whiteColor(),0);
    button.setTitleColorForState(this.highlightColor, 1);
    button.backgroundColor = hexColorAlpha("#9bb2d6",0.8);
    button.layer.cornerRadius = 8;
    button.layer.masksToBounds = true;
    if (targetAction) {
      button.addTargetActionForControlEvents(this, targetAction, 1 << 6);
    }
    this.view.addSubview(button);
}


chatglmController.prototype.createButton = function (buttonName,targetAction,superview) {
    this[buttonName] = UIButton.buttonWithType(0);
    this[buttonName].autoresizingMask = (1 << 0 | 1 << 3);
    this[buttonName].setTitleColorForState(UIColor.whiteColor(),0);
    this[buttonName].setTitleColorForState(this.highlightColor, 1);
    this[buttonName].backgroundColor = hexColorAlpha("#9bb2d6",0.8)
    this[buttonName].layer.cornerRadius = 8;
    this[buttonName].layer.masksToBounds = true;
    this[buttonName].titleLabel.font = UIFont.systemFontOfSize(16);

    if (targetAction) {
      this[buttonName].addTargetActionForControlEvents(this, targetAction, 1 << 6);
    }
    if (superview) {
      this[superview].addSubview(this[buttonName])
    }else{
      this.view.addSubview(this[buttonName]);
    }
}

chatglmController.prototype.settingViewLayout = function (){
    let viewFrame = this.view.bounds
    let width = viewFrame.width
    let height = viewFrame.height
    this.settingView.frame = {x:0,y:20,width:width,height:height-20}
    this.configView.frame = genFrame(0,40,width-2,height-60)
    this.knowledgeView.frame = genFrame(0,40,width-2,height-60)
    this.autoActionView.frame = genFrame(0,40,width-2,height-60)
    this.advanceView.frame = genFrame(0,40,width-2,height-60)
    this.donationView.frame = genFrame(0,60,width-2,height-80)
    let imageWidth = Math.min(width-22,height-120)
    this.QRCode.frame = {x:10,y:0,width:imageWidth,height:imageWidth}

    // advanceView
    this.orderButton.frame = genFrame(10,15,width-20,35)
    this.dynamicButton.frame = genFrame(10,55,(width-25)*0.35,35)
    this.dynamicFuncButton.frame = genFrame(15+(width-25)*0.35,55,(width-25)*0.35,35)
    this.dynamicPromptButton.frame = genFrame(20+(width-25)*0.70,55,(width-25)*0.30-5,35)
    this.dynamicNoteInput.frame = genFrame(10, 95, width-20,(height-170)*0.5)
    this.dynamicTextInput.frame = genFrame(10, 100+(height-170)*0.5, width-20,(height-170)*0.5)
    this.sourceButton.frame = genFrame(10,190,(width-25)*0.5,35)
    this.windowLocationButton.frame = genFrame(15+(width-25)*0.5,190,(width-25)*0.5,35)

    this.OCRSourceButton.frame = genFrame(10,100,width-20,35)
    this.OCRKeyPaste.frame = genFrame(10,140,90,40)
    this.OCRKeyInput.frame = genFrame(105,140,width-115,40)

    this.apiKeyButton.frame = genFrame(10,230,90,55)
    this.tunnelButton.frame = genFrame(10,230,(width-25)*0.5-30,40)
    this.refreshButton.frame = genFrame(10,275,width-20,40)
    this.usageButton.frame = genFrame(15+(width-25)*0.5-30,230,(width-25)*0.5+30,40)
    this.apiKeyInput.frame = genFrame(105,230,width-115,55)

    this.URLButton.frame = genFrame(10,290,90,40)
    this.URLInput.frame = genFrame(105,290,width-115,40)
    // this.SystemSave.frame = genFrame(10,height-140,90,40)
    // this.SystemInput.frame = genFrame(105,205,width-115,height-305)
    switch (this.config.source) {
      case "ChatGLM":
        this.modelButton.frame = genFrame(10,290,width-20,40)
        break;
      case "KimiChat":
        this.modelButton.frame = genFrame(10,290,width-20,40)
        break;
      case "ChatGPT":
        this.modelButton.frame = genFrame(10,335,width-20,40)
        break;
      default:
        break;
    }
    this.customUsage.frame = genFrame(10,380,width-20,40)

    //autoaction
    
    this.autoActionButton.frame = genFrame(10,15,width-20,35)
    this.onSelectionButton.frame = genFrame(10,60,(width-25)*0.5,35)
    this.delayButton.frame = genFrame((width-25)*0.5+15,60,(width-25)*0.5,35)
    this.onNewExcerptButton.frame = genFrame(10,105,(width-20),35)
    this.onNoteButton.frame = genFrame(10,240,(width-20),35)
    this.ignoreButton.frame = genFrame(10,370,(width-20),35)


    this.contextInput.frame = {x:10,y:215,width:width-20,height:height-320}
    this.systemInput.frame = {x:10,y:215,width:width-20,height:height-320}
    this.knowledgeInput.frame = {x:10,y:15,width:width-20,height:height-125}
    this.saveKnowledgeButton.frame = {x:10,y:height-105,width:width-20,height:35}
    this.titleInput.frame = {x:10,y:175,width:width-100,height:35}
    this.funcButton.frame = {x:width-85,y:175,width:75,height:35}
    this.saveButton.frame = {x:width-80,y:height-100,width:70,height:30}
    this.runButton.frame = {x:width-190,y:height-100,width:105,height:30}
    this.scrollview.frame = {x:10,y:15,width:width-20,height:150}
    this.scrollview.contentSize = {width:width-20,height:height};
    this.newEntryButton.frame = {x:width-45,y:130,width:30,height:30}
    this.addVarButton.frame = {x:width-45,y:height-140,width:30,height:30}
    this.configReset.frame = {x:width-110,y:130,width:60,height:30}
    this.deleteButton.frame = {x:width-175,y:130,width:60,height:30}
    this.SystemButton.frame = {x:95,y:height-100,width:80,height:30}
    this.contextButton.frame = {x:10,y:height-100,width:80,height:30}

    let initX = 10
    let initY = 145

    for (let index = 0; index < 32; index++) {
      if (index == 8) {
        initX = 10
        initY = 190
      }
      if (index == 16) {
        initX = 10
        initY = 280
      }
      if (index == 24) {
        initX = 10
        initY = 325
      }
      this["ColorButton"+index].frame = genFrame(initX,initY,40,40)
      this["ColorButton"+index].setTitleForState(this.config.colorConfig[index]?"✓":"✖️",0)
      initX = initX+45
    }


    let settingFrame = this.settingView.bounds
    settingFrame.x = 5
    settingFrame.y = 5
    settingFrame.height = 40
    settingFrame.width = settingFrame.width-10
    this.tabView.frame = settingFrame
    settingFrame.width = 80
    settingFrame.y = 10
    settingFrame.x = 10
    settingFrame.height = 30
    this.configButton.frame = settingFrame
    settingFrame.x = 95
    settingFrame.width = 100
    this.knowledgeButton.frame = settingFrame
    settingFrame.x = 200
    settingFrame.width = 70
    this.actionButton.frame = settingFrame
    settingFrame.x = 275
    settingFrame.width = 90
    this.advancedButton.frame = settingFrame
}
/**
 * @this {chatglmController}
 */
chatglmController.prototype.createSettingView = function (){
try {
  

  this.creatView("settingView","view","#ffffff",1.0)
  this.settingView.hidden = true
  this.creatView("tabView","settingView")
  this.creatView("configView","settingView","#9bb2d6",0.0)

  this.creatView("knowledgeView","settingView","#9bb2d6",0.0)
  this.knowledgeView.hidden = true

  this.creatView("autoActionView","settingView","#9bb2d6",0.0)
  this.autoActionView.hidden = true

  this.creatView("advanceView","settingView","#9bb2d6",0.0)
  this.advanceView.hidden = true

  this.creatView("donationView","settingView","#9bb2d6",0.0)
  this.donationView.hidden = true

  this.QRCode = UIImageView.new()
  this.QRCode.image = this.QRCodeImage
  this.donationView.addSubview(this.QRCode)


  this.createButton("configButton","configButtonTapped:","settingView")
  this.configButton.backgroundColor = hexColorAlpha("#457bd3",0.8)
  this.configButton.layer.opacity = 1.0
  this.configButton.setTitleForState("Prompts",0)
  this.configButton.titleLabel.font = UIFont.boldSystemFontOfSize(16)


  this.createButton("knowledgeButton","knowledgeButtonTapped:","settingView")
  // this.knowledgeButton.backgroundColor = hexColorAlpha("#457bd3",0.8)
  this.knowledgeButton.layer.opacity = 1.0
  this.knowledgeButton.setTitleForState("Knowledge",0)
  this.knowledgeButton.titleLabel.font = UIFont.boldSystemFontOfSize(16)

  this.createButton("actionButton","actionButtonTapped:","settingView")
  // this.actionButton.backgroundColor = hexColorAlpha("#457bd3",0.8)
  this.actionButton.layer.opacity = 1.0
  this.actionButton.setTitleForState("Action",0)
  this.actionButton.titleLabel.font = UIFont.boldSystemFontOfSize(16)

  this.createButton("advancedButton","advancedButtonTapped:","settingView")
  // this.advancedButton.backgroundColor = hexColorAlpha("#457bd3",0.8)
  this.advancedButton.layer.opacity = 1.0
  this.advancedButton.setTitleForState("Advanced",0)
  this.advancedButton.titleLabel.font = UIFont.boldSystemFontOfSize(16)

  this.createButton("orderButton","changeSearchOrder:","advanceView")
  this.orderButton.layer.opacity = 1.0
  this.orderButton.backgroundColor = hexColorAlpha("#457bd3",0.8)
  this.orderButton.setTitleForState(getOrderText(this.config.searchOrder),0)

  this.createButton("sourceButton","changeSource:","advanceView")
  this.sourceButton.layer.opacity = 1.0
  this.sourceButton.backgroundColor = hexColorAlpha("#457bd3",0.8)
  this.sourceButton.setTitleForState("Source: "+this.config.source,0)

  this.createButton("apiKeyButton","pasteApiKey:","advanceView")
  this.apiKeyButton.layer.opacity = 1.0
  this.apiKeyButton.backgroundColor = hexColorAlpha("#457bd3",0.8)
  this.apiKeyButton.setTitleForState("Paste Key",0)

  this.createButton("URLButton","pasteURL:","advanceView")
  this.URLButton.layer.opacity = 1.0
  this.URLButton.backgroundColor = hexColorAlpha("#457bd3",0.8)
  this.URLButton.setTitleForState("Paste URL",0)

  this.createButton("tunnelButton","changeTunnel:","advanceView")
  this.tunnelButton.layer.opacity = 1.0
  this.tunnelButton.backgroundColor = hexColorAlpha("#457bd3",0.8)
  let tunnels = ['Tunnel: 1️⃣','Tunnel: 2️⃣','Tunnel: 3️⃣','Tunnel: 4️⃣']
  this.tunnelButton.setTitleForState(tunnels[this.config.tunnel],0)
  this.createButton("refreshButton","refreshKey:","advanceView")
  this.refreshButton.layer.opacity = 1.0
  this.refreshButton.backgroundColor = hexColorAlpha("#457bd3",0.8)
  if (this.keys.aivesa && this.keys.keyLong) {
    this.refreshButton.setTitleForState(`Refresh (1️⃣: ${this.keys.aivesa.length}, 2️⃣: ${this.keys.keyLong.length}, 3️⃣: 1, 4️⃣: 1)`,0)
  }else{
    this.refreshButton.setTitleForState("Refresh",0)
  }


  this.createButton("usageButton","refreshUsage:","advanceView")
  this.usageButton.builtIn = true
  this.usageButton.layer.opacity = 1.0
  this.usageButton.backgroundColor = hexColorAlpha("#457bd3",0.8)
  let usage  = getUsage()
  this.usageButton.setTitleForState("Usage: "+usage.usage+"/100",0)

  this.createButton("windowLocationButton","toggleWindowLocation:","advanceView")
  this.windowLocationButton.layer.opacity = 1.0
  this.windowLocationButton.backgroundColor = hexColorAlpha("#457bd3",0.8)
  let locInd = this.config.notifyLoc
    switch (locInd) {
      case 0:
        this.windowLocationButton.setTitleForState("Notification: Left",0)
        break;
      case 1:
        this.windowLocationButton.setTitleForState("Notification: Right",0)
        break;
      default:
        break;
    }

  this.createButton("dynamicButton","toggleDynamic:","advanceView")
  this.dynamicButton.layer.opacity = 1.0
  this.dynamicButton.backgroundColor = hexColorAlpha("#457bd3",0.8)
  if (this.config.dynamic) {
    this.dynamicButton.setTitleForState("Dynamic: ✅",0)
  }else{
    this.dynamicButton.setTitleForState("Dynamic: ❌",0)
  }

  this.createButton("dynamicFuncButton","changeFunc:","advanceView")
  this.dynamicFuncButton.layer.opacity = 1.0
  this.dynamicFuncButton.backgroundColor = hexColorAlpha("#457bd3",0.8)
  this.dynamicFuncButton.setTitleForState("Function",0)
  this.dynamicFuncButton.func = true

  this.createButton("dynamicPromptButton","inputDynamicPrompt:","advanceView")
  this.dynamicPromptButton.layer.opacity = 1.0
  this.dynamicPromptButton.backgroundColor = hexColorAlpha("#457bd3",0.8)
  this.dynamicPromptButton.setTitleForState("System",0)
  this.dynamicPromptButton.func = true

  this.creatTextView("dynamicNoteInput","advanceView")
  this.dynamicNoteInput.hidden = true
  this.dynamicNoteInput.layer.opacity = 1.0
  this.dynamicNoteInput.backgroundColor = hexColorAlpha("#c0bfbf",1.0)


  this.creatTextView("dynamicTextInput","advanceView")
  this.dynamicTextInput.hidden = true
  this.dynamicTextInput.layer.opacity = 1.0
  this.dynamicTextInput.backgroundColor = hexColorAlpha("#c0bfbf",1.0)

  this.createButton("OCRSourceButton",undefined,"advanceView")
  this.OCRSourceButton.layer.opacity = 1.0
  this.OCRSourceButton.backgroundColor = hexColorAlpha("#457bd3",0.8)
  this.OCRSourceButton.setTitleForState("Simpletex OCR",0)

  this.creatTextView("OCRKeyInput","advanceView")
  this.OCRKeyInput.hidden = false
  this.OCRKeyInput.layer.opacity = 1.0
  this.OCRKeyInput.backgroundColor = hexColorAlpha("#c0bfbf",1.0)
  if (this.config.simpleTexKey) {
    this.OCRKeyInput.text = this.config.simpleTexKey
  }

  this.createButton("OCRKeyPaste","pasteOCRKey:","advanceView")
  this.OCRKeyPaste.layer.opacity = 1.0
  this.OCRKeyPaste.backgroundColor = hexColorAlpha("#457bd3",0.8)
  this.OCRKeyPaste.setTitleForState("Paste Key",0)

  this.createButton("autoActionButton","toggleAutoAction:","autoActionView")
  this.createButton("onSelectionButton","toggleOnSelection:","autoActionView")
  this.createButton("onNoteButton","toggleOnNote:","autoActionView")
  this.createButton("onNewExcerptButton","toggleOnNewExcerpt:","autoActionView")
  this.createButton("ignoreButton","toggleIgnoreShortText:","autoActionView")
  this.ignoreButton.setTitleForState("Ignore short text: "+(this.config.ignoreShortText?"✅":"🚫"),0)
  if (this.config.ignoreShortText) {
    this.ignoreButton.backgroundColor = hexColorAlpha("#457bd3",0.8)
  }else{
    this.ignoreButton.backgroundColor = hexColorAlpha("#9bb2d6",0.8)
  }
  this.autoActionButton.layer.opacity = 1.0
  if (this.config.autoAction) {
    this.autoActionButton.backgroundColor = hexColorAlpha("#457bd3",0.8)
    this.autoActionButton.setTitleForState("Auto Action: ✅",0)
    this.onSelectionButton.hidden = false
    this.onNewExcerptButton.hidden = false
    this.onNoteButton.hidden = false
    this.ignoreButton.hidden = false

  }else{
    this.autoActionButton.backgroundColor = hexColorAlpha("#9bb2d6",0.8)
    this.autoActionButton.setTitleForState("Auto Action: ❌",0)
    this.onSelectionButton.hidden = true
    this.onNewExcerptButton.hidden = true
    this.onNoteButton.hidden = true
    this.ignoreButton.hidden = true

  }

  if (this.config.onSelection) {
    this.onSelectionButton.backgroundColor = hexColorAlpha("#457bd3",0.8)
    this.onSelectionButton.setTitleForState("On Selection: ✅",0)
  }else{
    this.onSelectionButton.backgroundColor = hexColorAlpha("#9bb2d6",0.8)
    this.onSelectionButton.setTitleForState("On Selection: ❌",0)
  }

  if (this.config.onNote) {
    this.onNoteButton.backgroundColor = hexColorAlpha("#457bd3",0.8)
    this.onNoteButton.setTitleForState("On Note: ✅",0)
  }else{
    this.onNoteButton.backgroundColor = hexColorAlpha("#9bb2d6",0.8)
    this.onNoteButton.setTitleForState("On Note: ❌",0)
  }

  if (this.config.onNewExcerpt) {
    this.onNewExcerptButton.backgroundColor = hexColorAlpha("#457bd3",0.8)
    this.onNewExcerptButton.setTitleForState("On New Excerpt: ✅",0)
  }else{
    this.onNewExcerptButton.backgroundColor = hexColorAlpha("#9bb2d6",0.8)
    this.onNewExcerptButton.setTitleForState("On New Excerpt: ❌",0)
  }

  this.createButton("delayButton","changeDelay:","autoActionView")
  this.delayButton.setTitleForState("Delay: "+this.config.delay+"s",0)
  this.delayButton.backgroundColor = hexColorAlpha("#457bd3",0.8)
  if (!this.config.autoAction) {
    this.delayButton.hidden = true
  }
  
  this.createButton("modelButton","changeModel:","advanceView")
  let modelNames = []
  switch (this.config.source) {
    case "ChatGLM":
      modelNames = ["GLM-3-Turbo","GLM-4"]
      this.modelButton.setTitleForState("Model: "+modelNames[this.config.chatglmModel],0)
      break;
    case "ChatGPT":
      modelNames = getModelNames("ChatGPT")
      this.modelButton.setTitleForState("Model: "+modelNames[this.config.model],0) 
      break
    case "KimiChat":
      modelNames = getModelNames("KimiChat")
      this.modelButton.setTitleForState("Model: "+modelNames[this.config.moonshotModel],0) 
      break
    default:
      break;
  }
  this.modelButton.backgroundColor = hexColorAlpha("#457bd3",0.8)

  this.createButton("customUsage","refreshUsage:","advanceView")
  this.customUsage.builtIn = false
  this.customUsage.setTitleForState("Usage:",0)
  this.customUsage.backgroundColor = hexColorAlpha("#457bd3",0.8)

  this.creatTextView("apiKeyInput","advanceView")
  let apikey
  if (this.config.source === "ChatGLM") {
    apikey = this.config.apikey
  }else{
    apikey = this.config.openaiKey
  }
  if (this.apikey === "") {
    apikey = `Paste your api key here`
  }
  this.apiKeyInput.text = apikey
  this.apiKeyInput.bounces = true
  this.apiKeyInput.editable = false

  this.creatTextView("URLInput","advanceView")
  let URL = this.config.url
  if (URL === "") {
    URL = `https://api.openai.com`
  }
  this.URLInput.text = URL
  this.URLInput.bounces = true
  this.URLInput.editable = false
  switch (this.config.source) {
    case "ChatGLM":
      this.URLButton.hidden = true
      this.URLInput.hidden = true
      this.modelButton.hidden = false
      this.customUsage.hidden = true
      this.usageButton.hidden = true
      this.refreshButton.hidden = true
      this.tunnelButton.hidden = true
      break;
    case "KimiChat":
      this.URLButton.hidden = true
      this.URLInput.hidden = true
      this.modelButton.hidden = false
      this.customUsage.hidden = true
      this.usageButton.hidden = true
      this.refreshButton.hidden = true
      this.tunnelButton.hidden = true
      break;
    case "ChatGPT":
      this.URLButton.hidden = false
      this.URLInput.hidden = false
      this.usageButton.hidden = true
      this.modelButton.hidden = false
      this.customUsage.hidden = false
      this.refreshButton.hidden = true
      this.tunnelButton.hidden = true
      break;
    case "Built-in":
      this.URLButton.hidden = true
      this.URLInput.hidden = true
      this.modelButton.hidden = true
      this.customUsage.hidden = true
      this.apiKeyInput.hidden = true
      this.usageButton.hidden = false
      this.apiKeyButton.hidden = true
      this.refreshButton.hidden = false
      this.tunnelButton.hidden = false
    default:
      break;
  }

  this.scrollview = UIScrollView.new()
  this.configView.addSubview(this.scrollview)
  this.scrollview.hidden = false
  this.scrollview.delegate = this
  this.scrollview.bounces = true
  this.scrollview.alwaysBounceVertical = true
  this.scrollview.layer.cornerRadius = 8
  this.scrollview.backgroundColor = hexColorAlpha("#c0bfbf",0.8)

  this.creatTextView("contextInput","configView")
  this.creatTextView("systemInput","configView")
  this.systemInput.hidden = true

  this.creatTextView("titleInput","configView","#9bb2d6")
  this.creatTextView("knowledgeInput","knowledgeView")
  this.knowledgeInput.text = getLocalDataByKeyDefault('MNChatglm_knowledge',"")
  // let entries           = NSUserDefaults.standardUserDefaults().objectForKey('MNBrowser_entries');
  // copyJSON(this.prompts)
  // copy(text)
  let text  = this.prompts[this.config.currentPrompt]
  this.contextInput.text = text.context?text.context:""
  this.titleInput.text = text.title
  this.titleInput.contentInset = {top: 0,left: 0,bottom: 0,right: 0}
  this.titleInput.textContainerInset = {top: 0,left: 0,bottom: 0,right: 0}
  this.createButton("funcButton","changeFunc:","configView")
  this.funcButton.layer.opacity = 1.0
  this.funcButton.setTitleForState("Func",0)

  this.createButton("configReset","resetConfig:","configView")
  this.configReset.layer.opacity = 1.0
  this.configReset.setTitleForState("Reset",0)

  this.createButton("saveButton","configSaveTapped:","configView")
  this.saveButton.layer.opacity = 1.0
  this.saveButton.setTitleForState("Save",0)

  this.createButton("runButton","askWithPrompt:","configView")
  this.runButton.layer.opacity = 1.0
  this.runButton.setTitleForState("Save & Ask",0)

  this.createButton("deleteButton","configDeleteTapped:","configView")
  this.deleteButton.layer.opacity = 1.0
  this.deleteButton.setTitleForState("Delete",0)
  this.createButton("newEntryButton","configAddTapped:","configView")
  this.newEntryButton.layer.opacity = 1.0
  this.newEntryButton.setTitleForState("➕",0)

  this.createButton("addVarButton","addVariable:","configView")
  this.addVarButton.layer.opacity = 1.0
  this.addVarButton.setTitleForState("➕",0)

  this.createButton("contextButton","configContextTapped:","configView")
  this.contextButton.layer.opacity = 1.0
  this.contextButton.setTitleForState("Context",0)
  this.contextButton.backgroundColor = hexColorAlpha("#457bd3",0.8)

  this.createButton("SystemButton","configSystemTapped:","configView")
  this.SystemButton.layer.opacity = 1.0
  // this.SystemButton.backgroundColor = hexColorAlpha("#457bd3",0.8)
  this.SystemButton.backgroundColor = hexColorAlpha("#9bb2d6",0.8)
  this.SystemButton.setTitleForState("System",0)

  this.createButton("saveKnowledgeButton","saveKnowledgeButtonTapped","knowledgeView")
  this.saveKnowledgeButton.layer.opacity = 1.0
  this.saveKnowledgeButton.setTitleForState("Save",0)
  this.saveKnowledgeButton.backgroundColor = hexColorAlpha("#457bd3",0.8)

  let color = ["#ffffb4","#ccfdc4","#b4d1fb","#f3aebe","#ffff54","#75fb4c","#55bbf9","#ea3323","#ef8733","#377e47","#173dac","#be3223","#ffffff","#dadada","#b4b4b4","#bd9fdc"]
    for (let index = 0; index < 32; index++) {
      this["ColorButton"+index]   = UIButton.buttonWithType(0);
      this["ColorButton"+index].index = index
      this["ColorButton"+index].hidden = !this.config.autoAction
      if (index > 15) {
        this.setColorButtonLayout(this["ColorButton"+index],"toggleColorConfig:",color[index-16])
      }else{
        this.setColorButtonLayout(this["ColorButton"+index],"toggleColorConfig:",color[index])
      }
      // self["ColorButton"+index].setTitleForState(self.imagePattern[index]===self.textPattern[index]?` ${self.imagePattern[index]} `:"-1",0) 
    }
} catch (error) {
  showHUD(error)
}
}

/**
 * @this {chatglmController}
 */
chatglmController.prototype.setButtonText = function (names,highlight) {
    this.words = names

    names.map((word,index)=>{
      if (!this["nameButton"+index]) {
        this.createButton("nameButton"+index,"toggleSelected:","scrollview")
        // this["nameButton"+index].index = index
        this["nameButton"+index].titleLabel.font = UIFont.systemFontOfSize(16);
      }
      this["nameButton"+index].hidden = false
      // this["nameButton"+index].tag = 
      // if (!this.entries[word]) {
        
      // }
      this["nameButton"+index].setTitleForState(this.prompts[word].title,0) 
      this["nameButton"+index].id = word

      if (word === highlight) {
        this["nameButton"+index].backgroundColor = hexColorAlpha("#457bd3",0.8)
        this["nameButton"+index].isSelected = true
      }else{
        this["nameButton"+index].backgroundColor = hexColorAlpha("#9bb2d6",0.8);
        this["nameButton"+index].isSelected = false
      }
      // this["nameButton"+index].titleEdgeInsets = {top:0,left:-100,bottom:0,right:-50}
      // this["nameButton"+index].setTitleForState(this.imagePattern[index]===this.textPattern[index]?` ${this.imagePattern[index]} `:"-1",0) 
    })
    this.refreshLayout()
}
/**
 * @this {chatglmController}
 */
chatglmController.prototype.setTextview = function (name) {
      // let entries           =  NSUserDefaults.standardUserDefaults().objectForKey('MNBrowser_entries');
      let text  = this.prompts[name]
      this.titleInput.text= text.title
      this.contextInput.text = text.context?text.context:""
      if (!text.system) {
        text.system = ""
      }
      this.systemInput.text = text.system

}
/**
 * @this {chatglmController}
 */
chatglmController.prototype.refreshLayout = function () {
  if (!this.settingView) {return}
  if (!this.configView.hidden) {
    var viewFrame = this.scrollview.bounds;
    var xLeft     = 0
    let initX = 10
    let initY = 10
    let initL = 0
    this.locs = [];
    this.words.map((word,index)=>{
      let title = this.prompts[word].title
      let width = strCode(title.replaceAll(" ",""))*9+15
      if (xLeft+initX+width > viewFrame.width-10) {
        initX = 10
        initY = initY+40
        initL = initL+1
      }
      this["nameButton"+index].frame = {  x: xLeft+initX,  y: initY,  width: width,  height: 30,};
      this.locs.push({
        x:xLeft+initX,
        y:initY,
        l:initL,
        i:index
      })
      initX = initX+width+10
    })
    if (this.lastLength && this.lastLength>this.words.length) {
      for (let index = this.words.length; index < this.lastLength; index++) {
        this["nameButton"+index].hidden = true
      }
    }
    this.lastLength = this.words.length
    this.scrollview.contentSize= {width:viewFrame.width,height:initY+40}
  
  }
}

chatglmController.prototype.hideAllButton = function (frame) {
  this.moveButton.hidden = true
  this.closeButton.hidden = true
  this.maxButton.hidden = true
}
chatglmController.prototype.showAllButton = function (frame) {
  this.moveButton.hidden = false
  this.closeButton.hidden = false
  this.maxButton.hidden = false
}
/**
 * @this {chatglmController}
 */
chatglmController.prototype.show = function (frame) {
  studyController().view.bringSubviewToFront(this.view)
  studyController().view.bringSubviewToFront(this.addonBar)
  let preFrame = this.currentFrame
  let preOpacity = this.view.layer.opacity
  this.view.layer.opacity = 0.2
  // this.settingView.hidden = true
  // if (frame) {
  //   this.view.frame = frame
  //   this.currentFrame = frame
  // }
  this.view.hidden = false
  this.miniMode = false
  this.hideAllButton()

  UIView.animateWithDurationAnimationsCompletion(0.2,()=>{
    this.view.layer.opacity = preOpacity
    // this.view.frame = preFrame
    // this.currentFrame = preFrame
  },
  ()=>{
    this.view.layer.borderWidth = 0
    this.showAllButton()
    try {
      
    this.settingView.hidden = false
    } catch (error) {
      showHUD(error)
    }
  })
}
chatglmController.prototype.hide = function (frame) {
  studyController().view.bringSubviewToFront(this.addonBar)
  let preFrame = this.view.frame
  let preOpacity = this.view.layer.opacity
  let preCustom = this.custom
  this.hideAllButton()
  this.custom = false
  UIView.animateWithDurationAnimationsCompletion(0.25,()=>{
    this.view.layer.opacity = 0.2
    // if (frame) {
    //   this.view.frame = frame
    //   this.currentFrame = frame
    // }
    // this.view.frame = {x:preFrame.x+preFrame.width*0.1,y:preFrame.y+preFrame.height*0.1,width:preFrame.width*0.8,height:preFrame.height*0.8}
    // this.currentFrame = {x:preFrame.x+preFrame.width*0.1,y:preFrame.y+preFrame.height*0.1,width:preFrame.width*0.8,height:preFrame.height*0.8}
  },
  ()=>{
    this.view.hidden = true;
    this.view.layer.opacity = preOpacity      
    this.view.frame = preFrame
    this.currentFrame = preFrame
    this.custom = preCustom
    // this.view.frame = preFrame
    // this.currentFrame = preFrame
  })
}

chatglmController.prototype.creatView = function (viewName,superview="view",color="#9bb2d6",alpha=0.8) {
  this[viewName] = UIView.new()
  this[viewName].backgroundColor = hexColorAlpha(color,alpha)
  this[viewName].layer.cornerRadius = 12
  this[superview].addSubview(this[viewName])
}

chatglmController.prototype.creatTextView = function (viewName,superview="view",color="#c0bfbf",alpha=0.8) {
  this[viewName] = UITextView.new()
  this[viewName].font = UIFont.systemFontOfSize(15);
  this[viewName].layer.cornerRadius = 8
  this[viewName].backgroundColor = hexColorAlpha(color,alpha)
  this[viewName].textColor = UIColor.blackColor()
  this[viewName].delegate = this
  this[viewName].bounces = true
  this[superview].addSubview(this[viewName])
}


chatglmController.prototype.setColorButtonLayout = function (button,targetAction,color) {
    button.autoresizingMask = (1 << 0 | 1 << 3);
    button.setTitleColorForState(UIColor.blackColor(),0);
    button.setTitleColorForState(this.highlightColor, 1);
    button.backgroundColor = UIColor.colorWithHexString(color).colorWithAlphaComponent(0.8);
    button.layer.cornerRadius = 10;
    button.layer.masksToBounds = true;
    button.layer.borderWidth = 2
    if (targetAction) {
      button.addTargetActionForControlEvents(this, targetAction, 1 << 6);
    }
    this.autoActionView.addSubview(button);
}

/**
 * @this {chatglmController}
 */
chatglmController.prototype.fetchKeys = async function (authorization,string) {
  // let url = `https://usage.feliks.top?query=key`
  let url = `https://file.feliks.top/sharedKeys.json`

  try {
    const res = await this.fetch(url,
      {
        method: "Get",
        timeout: 60
      }
    )
    return res;
  } catch (error) {
    showHUD(error)
    return undefined
  }
}

chatglmController.prototype.getUsage = async function (authorization,string) {
  let url = this.config.url
  let urlSubscription = url+'/v1/dashboard/billing/subscription'
  let urlUsage = url+"/v1/dashboard/billing/usage"

  let key = this.config.openaiKey
  if (key.trim() === "") {
    showHUD("no api key")
    return
  }
  let headers = {
      'Authorization': 'Bearer '+key,
      "Content-Type": "application/json"
  }
  let usage = {}
  const res = await this.fetch(urlUsage,
    {
      method: "GET",
      timeout: 60,
      headers: headers
    }
  )
  usage.usage = res.total_usage
  const total = await this.fetch(urlSubscription,
    {
      method: "GET",
      timeout: 60,
      headers: headers
    }
  )
  usage.total = total.hard_limit_usd
  return usage;
}
/**
 * @this {chatglmController}
 */
chatglmController.prototype.fetch = async function (url,options = {}){
  return new Promise((resolve, reject) => {
    // UIApplication.sharedApplication().networkActivityIndicatorVisible = true
    const queue = NSOperationQueue.mainQueue()
    const request = this.initRequest(url, options)
    NSURLConnection.sendAsynchronousRequestQueueCompletionHandler(
      request,
      queue,
      (res, data, err) => {
        if (err.localizedDescription) reject(err.localizedDescription)
        // if (data.length() === 0) resolve({})
        const result = NSJSONSerialization.JSONObjectWithDataOptions(
          data,
          1<<0
        )
        if (NSJSONSerialization.isValidJSONObject(result)) resolve(result)
        resolve(result)
      }
    )
  })
}
/**
 * @this {chatglmController}
 */
chatglmController.prototype.initRequest = function (url,options) {
  const request = NSMutableURLRequest.requestWithURL(genNSURL(url))
  request.setHTTPMethod(options.method ?? "GET")
  request.setTimeoutInterval(options.timeout ?? 10)
  const headers = {
    "User-Agent":
      "Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/13.1.1 Safari/605.1.15",
    "Content-Type": "application/json",
    Accept: "application/json"
  }
  request.setAllHTTPHeaderFields({
    ...headers,
    ...(options.headers ?? {})
  })
  if (options.search) {
    request.setURL(
      genNSURL(
        `${url.trim()}?${Object.entries(options.search).reduce((acc, cur) => {
          const [key, value] = cur
          return `${acc ? acc + "&" : ""}${key}=${encodeURIComponent(value)}`
        }, "")}`
      )
    )
  } else if (options.body) {
    request.setHTTPBody(NSData.dataWithStringEncoding(options.body, 4))
  } else if (options.form) {
    request.setHTTPBody(
      NSData.dataWithStringEncoding(
        Object.entries(options.form).reduce((acc, cur) => {
          const [key, value] = cur
          return `${acc ? acc + "&" : ""}${key}=${encodeURIComponent(value)}`
        }, ""),
        4
      )
    )
  } else if (options.json) {
    request.setHTTPBody(
      NSJSONSerialization.dataWithJSONObjectOptions(
        options.json,
        1
      )
    )
  }
  return request
}
/**
 * @this {chatglmController}
 */
chatglmController.prototype.genCardStructure = function (OCR_enabled=false) {
  // let hasImage = false
  let cardStructure = {}
  // let noteId  = this.currentNoteId
  let note = getNoteById(this.currentNoteId)
  // if (!note) {
  //   showHUD(this.currentNoteId)
  //   showHUD("no note")
  //   return ""
  // }
  if (note.noteTitle && note.noteTitle !== "") {
    cardStructure.title = note.noteTitle
  }
  if (OCR_enabled && note.excerptPic && !note.textFirst) {
    cardStructure.excerpt = {image:note.excerptPic.paint}
    // hasImage = true
  }else if (noteHasExcerptText(note)){
    cardStructure.excerpt = note.excerptText
  }
  if (note.comments.length) {
    let comments = []
    note.comments.map(comment=>{
      switch (comment.type) {
        case "TextNote":
          if (/^marginnote3app:\/\//.test(comment.text)) {
            return false
          }else{
            comments.push(comment.text)
            return true
          }
        case "HtmlNote":
          comments.push(comment.text)
          return true
        case "LinkNote":
          if (OCR_enabled && comment.q_hpic && !note.textFirst) {
            comments.push({image:getMediaByHash(comment.q_hpic.paint)})
            return true
          }else{
            comments.push(comment.q_htext)
            return true
          }
        case "PaintNote":
          if (OCR_enabled && comment.paint){
            comments.push({image:getMediaByHash(comment.paint)})
            return true
          }
          return false
        default:
          return false
      }
    })
    cardStructure.comments = comments
  }
  return cardStructure
}

/**
 * @this {chatglmController}
 * @param {{name:String,path:String,md5:String}} fileObject
 */
chatglmController.prototype.getFileContent = async function (fileObject){

  let file_id = await this.getFileId(fileObject)
  if (this.fileContent[file_id]) {
    return JSON.stringify(this.fileContent[file_id],null,2)
  }
  showHUD("Get file content: "+fileObject.name)
  let key = this.config.moonshotKey
  if (!key) {
    showHUD("No Moonshot ApiKey!")
    return undefined
  }
  // let res = await upload(currentFile.path)
  // copy(res.id)
  let url = `https://api.moonshot.cn/v1/files/${file_id}/content`
  let headers = {
      Authorization: "Bearer "+key,
      "Content-Type": "application/json"
  }
  try {
    const res = await this.fetch(url,
      {
        method: "Get",
        timeout: 60,
        headers: headers
      }
    )
    
    // res.file_type = "application/pdf"
    res.filename = fileObject.name
    this.fileContent[file_id] = res
    // copyJSON(res)
    return JSON.stringify(res,null,2);
  } catch (error) {
    // showHUD(error)
    // copy(error)
    return undefined
  }
}

/**
 * @this {chatglmController}
 * @param {{name:String,path:String,md5:String}} fileObject
 */
chatglmController.prototype.getFileId = async function (fileObject){
  let fileMd5 = fileObject.md5
  if (this.fileId[fileMd5]) {
    return this.fileId[fileMd5]
  }
  let key = this.config.moonshotKey
  if (!key) {
    showHUD("No Moonshot ApiKey!")
    return undefined
  }
  showHUD("Upload file: "+fileObject.name)
  let fileId = (await upload(fileObject.path,key)).id
  this.fileId[fileMd5] = fileId
  setLocalDataByKey(this.fileId, "MNChatglm_fileId")
  return fileId
}

/**
 * @this {chatglmController}
 * @param {String} text
 */
chatglmController.prototype.ask = async function (text){
    let question = await this.getQuestion()
    if (!question) {
      return
    }
    // copyJSON(question)
    // let config = self.addonController.config
    this.notifyController.currentPrompt = this.config.currentPrompt
    this.notifyController.text = text
    this.notifyController.ask(question)
    return question
}

/**
 * @this {chatglmController}
 */
chatglmController.prototype.getBaiduToken = async function () {
  let baiduApiKey = "EzarruKGCNb9kj1IPQQSezIi"
  let baiduSecretKey = "6jjFjVlEkhTWSmDSnoGNowZBUvuxFnHw"
  const res = await this.fetch(
    `https://aip.baidubce.com/oauth/2.0/token?grant_type=client_credentials&client_id=${baiduApiKey}&client_secret=${baiduSecretKey}`
  )
  return res.access_token
}

/**
 * @this {chatglmController}
 */
chatglmController.prototype.baiduFormulaOCR = async function (imgBase64) {
  try {
    

  // const token = await this.getBaiduToken()
  const token = "24.c9f51dfe888d5b6894c20aca4806d800.2592000.1710775682.282335-51835107"
  // copy(token)
  // showHUD(token)
  const res = await this.fetch(
    `https://aip.baidubce.com/rest/2.0/ocr/v1/formula?access_token=${token}`,
    {
      method: "POST",
      headers: {
        "Content-Type": "application/x-www-form-urlencoded"
      },
      form: {
        image: imgBase64
      }
    }
  )
  if (res.error_code && res.error_msg)
    throw `Baidu OCR：${res.error_code} ${res.error_msg}`
  return res.words_result.map(k => k.words).join("")
    } catch (error) {
    showHUD(error)
  }
}
/**
 * 
 * @param {NSData} image 
 * @returns 
 */
chatglmController.prototype.getTextOCR = async function (image) {
    let keys = ["QiZazseqjwy24T9scI7Fdu7Q7LVKHLIesUkGnF6jul1NL5SWg5OH2665MnduCeLN","J4kjn51PoZQyBNAV1fnFzorvxm9HzJI3zYMYZK1EsGXrKCTcgB3wtMowFDPUnIKk"]
    let key = getRandomElement(keys)
    if (!this.md52image) {
      this.md52image = {}
    }
    let md5 = CryptoJS.MD5(image.base64Encoding()).toString();
    if (this.md52image[md5]) {
      showHUD("OCR result from buffer")
      return this.md52image[md5]
    }

    // this.md52image
    if (this.config.simpleTexKey) {
      key = this.config.simpleTexKey
      showHUD("OCR by simpleTex...")
    }else{
      let usage = getUsage()
      if (usage.usage >= usage.limit) {
        showHUD("Access limited")
        return false
      }else{
        usage.usage = usage.usage+1
        // showHUD("usage:"+usage.usage)
        setLocalDataByKey(usage,'MNChatglm_usage')
      }
      if (this.usageButton) {
        this.usageButton.setTitleForState("Usage: "+usage.usage+"/100",0)
      }
      showHUD("OCR by simpleTex (Built in)...")
    }
    try {
      let res = await ocrImage(image, key)
      this.md52image[md5] = res.res.latex
      return res.res.latex
    } catch (error) {
      showHUD(error)
      return undefined
    }
}
/** @type {UITextView} */
chatglmController.prototype.contextInput